#include<stdio.h>
#include<math.h>
#include<stdlib.h>

//#include"relpose.c"
//#include"jacobians.c"
//#include"headMove.c"

#define pi 3.141592653589793238
#define g 9.80665

void NN( float t, int r1, int r2, float w1[], float w2[], float ps1[r1][4], float ps2[r2][4], float zig1[r1][4],
         float zig2[r2][4], float e[], float vel_x, float vel_y_s, float vel_yaw_r,
         float acc_x[], float acc_y_s[], float dt, int totalSteps, float v[], float learn[]){


			float ip1[4], ip2[4];   	  /* i/p s to the NN subnets */
			int i,j,p;
			float ff1[r1], ff2[r2];           /* o/p s from neurons */
			float f1[r1], f2[r2];	          /* o/p s from neurons -- Normalized */
			float e_f[2];
			float ss = 1.0; // with error
			float pp = 1.0; // with error rate
			float E1, E2;
			float aa1[r1], aa2[r2];
			float deno1, deno2;
			float ewf1[r1][8], ewf2[r2][8]; /* terms of the product e_f*W*f'_zid */

			float l1_1 = 5.0*pow(2.73, -(pow(e[0],2)+pow(e[3],2))); //1.0;      /* Connecting weights -- Learning rate -- LONGIT  */
            float l1_2 = 50.0;//40.0;               /* Connecting weights -- Learning rate -- LATERAL */
            float k_w1 = 0.001;
			float k_w2 = 0.001;

			ip1[0] = vel_x;
			ip1[1] = vel_y_s;
			ip1[2] = vel_yaw_r;
			ip1[3] = acc_x[0];

            ip2[0] = vel_x;
			ip2[1] = vel_y_s;
			ip2[2] = vel_yaw_r;
			ip2[3] = 0.0 * acc_y_s[0];	// as lateral acceleration can be noisy when the vehicle negociates a sudden change in road curvature, one may use a filtered signal or simply assume it to be 0 without noticable degradation in controller performance

            learn[0] = l1_1;

	/* ********* Calculating ff_i[j] ; i = 1,2,3 ; j = 1, 2, ........r ********* */

		for (i=0; i<=r1-1; i++){
			ff1[i] = 1.0;
				for (j=0; j<=3; j++)
				    ff1[i] = ff1[i] * exp(-pow((ip1[j] - ps1[i][j]),2)/pow(zig1[i][j],2));
					//printf("%f\n",ff1[i]);
    	}

        for (i=0; i<=r2-1; i++){
			ff2[i] = 1.0;
				for (j=0; j<=3; j++)
				    ff2[i] = ff2[i] * exp(-pow((ip2[j] - ps2[i][j]),2)/pow(zig2[i][j],2));
					//printf("%f\n",ff2[i]);
    	}

    /* **************** Calculating sum of activations **************** */

		deno1 =0.0;
		for (i=0; i<=r1-1; i++){
			deno1 = deno1 + ff1[i];
		}

        deno2 =0.0;
		for (i=0; i<=r2-1; i++){
			deno2 = deno2 + ff2[i];
		}

    /* ****** Calculating the activations f_i[j] ; i = 1,2,3 ; j = 1,2,..........,r ****** */

    	for (i=0; i<=r1-1; i++){
		f1[i] = ff1[i];
		}

        for (i=0; i<=r2-1; i++){
		f2[i] = ff2[i]/deno2;
		}

    /* ******** Calculating e_f ******** */

    		for (i=0; i<=1; i++){
    			e_f[i] = ss*e[i] + pp*e[i+3];
    			//printf("%f\n",e_f[i]);
			}

	/* ****** Calculating Euclidan norms, ||E|| = E ****** */

			E1 = sqrt(pow(e[0],2) + pow(e[3],2));
    	//printf("%f\n",E1);

			E2 = sqrt(pow(e[1],2) + pow(e[4],2));
    	//printf("%f\n",E2);


    /* ***************** UPDATING CONNECTING WEIGHTS w1[r1]--LONGIT., w2[r2]--LAT. *************** */

	      	for (j=0; j<=r1-1; j++){
			   w1[j] = w1[j] + l1_1 * dt * (e_f[0] * f1[j] - k_w1 * E1 * w1[j]);
					//fprintf(fp, "w1[%d]=%f\n",i,j,w1[j]);
    		}

		for (j=0; j<=r2-1; j++){
			   w2[j] = w2[j] + l1_2 * dt * (e_f[1] * f2[j] - k_w2 * E2 * w2[j]);
					//fprintf(fp, "w2[%d]=%f\n",i,j,w2[j]);
                }

    /* ******** Calculating NN's signal vector v[2] to counteract uncertainties ******** */

	/* Calculating ff_i[j] ; i = 1,2,3; j = 1, 2, ........r */

		for (i=0; i<=r1-1; i++){
			ff1[i] = 1.0;
				for (j=0; j<=3; j++)
				      ff1[i] = ff1[i] * exp(-pow((ip1[j] - ps1[i][j]),2)/pow(zig1[i][j],2));
					//printf("%f\n",ff1[i]);
    		}

		for (i=0; i<=r2-1; i++){
			ff2[i] = 1.0;
				for (j=0; j<=3; j++)
				      ff2[i] = ff2[i] * exp(-pow((ip2[j] - ps2[i][j]),2)/pow(zig2[i][j],2));
					//printf("%f\n",ff2[i]);
    		}


    /* Calculating sum of activations */

		deno1 =0.0;
		for (i=0; i<=r1-1; i++){
			deno1 = deno1 + ff1[i];
		}

        deno2 =0.0;
		for (i=0; i<=r2-1; i++){
			deno2 = deno2 + ff2[i];
		}

    /* Calculating the activations f_i ; i = 1,2,..........,r */

    	for (i=0; i<=r1-1; i++){
			f1[i] = ff1[i];
		}

    	for (i=0; i<=r2-1; i++){
			f2[i] = ff2[i]/deno2;	// Here, activation has been normalized to test a different activation function for lateral control. This is called normalized Gaussian or SoftMax function which is also a radial basis function. By making Deno=1, one can impliment popular product type RBF
		}

			/* ********** Calculating v[2] ********** */

		for (i=0; i<=1; i++){
			v[i] = 0.0;
                }

                /* ******** LONGIT. NET ********* */

		for (j=0; j<=r1-1; j++){
			v[0] = v[0] + w1[j] * f1[j];
        }

                /* ******** LATERAL NET ********* */

		for (j=0; j<=r2-1; j++){
			v[1] = v[1] + w2[j] * f2[j];
        }

}

void control( float t, float v[2], float e_sp, float vel_x_d, float acc_x_d, float y_s, float yaw_r, float vel_x,
              float vel_y_s, float vel_yaw_r, float acc_x[], float acc_y_s[], float acc_yaw_r[], float T[],
              float steer[], float gg_x[], float gg_y_yaw[] ){

/* Computed torque controller */

        float rr1, h_x, h_y_s, h_yaw_r;
 		float g_x, g_y_yaw;

/* ** Model Parameters (From SAVRIN Data-sheet and k1&k2 guessed according to the book "THEORY OF Ground Vihicles")** */

        float m, I_z, Cf, Cr, a, b, k1, k2, f, d_s;
        float rho1, rho;
        float a0, b0, c0, xxx;

        // ******* Nominal Values for the Controller -- From SEVRIN Fact Sheet ********

		m   = 1640.0;       // Curb weight
		I_z = 3105.0;
		Cf  = 131391.0;
        Cr  = 115669.0;
		a   = 1.193;
		b   = 2.78 - a;
        k2  = 0.49;
        k1  = 0.008;
        f   = 0.02;
        d_s = a + 0.91;


        // ROAD PROFILE

        if ( t <= 5.0){
                rho = -1.0/1000.0;                                      
        }
                else if ( t > 5.0 && t <= 12.0){
                        rho = -1.0/1000.0;                  // Road -- Right curvature of radius 1000 m
                }
                        else if ( t > 12.0 && t <= 30.0 ){
                                rho = 1.0/1000.0;
                        }
                                else if ( t > 30.0 && t <= 43.0){
                                        rho = -1.0/740.0;
                                }
                                        else if ( t > 43.0 && t <= 55.0 ){
                                                rho = 0.0;	// Straight road
                                        }
                                                else {
                                                        rho = 1.0/500.0;
                                                }

// *************  FOR ADVERSE (ADHESSION = 0.4) CASE ***************

                                if ( t <= 55.0){
                                        rho = 0.0;
                                }
                                        else {
                                        rho = 1.0/500.0;
                                        }

// ***********************************************

                                xxx  = rand()/2147483647.0;
                                rho1 = rho;// * ( xxx * 0.1 + 0.95);  // measurement error +-5%
                                //rho1 = rho = 0.0;                   // For spacing error convergence tests
                                
                        // ********** CONTROLLER **********

        rr1 = m * a/(I_z + m * d_s * a);

        h_x     =  m * (vel_y_s - rho1 * d_s * vel_x) * vel_yaw_r + (f * k1 * a/(a+b) - k2) * pow(vel_x,2)
                  + m * rho1* vel_x * vel_y_s - m * d_s * pow(vel_yaw_r,2) - f*b*(m*g-k1*pow(vel_x,2))/(a+b);
        h_y_s   = -m * vel_x * vel_yaw_r - Cr*(1 - m*d_s*b/I_z) * (vel_y_s - (b+d_s)*vel_yaw_r)/vel_x
                  - m * rho1 * pow(vel_x,2) + rho1 * b * Cr * (1 - m*d_s*b/I_z)
                  - (1 + m*d_s*a/I_z) * Cf*(vel_y_s - d_s*vel_yaw_r + a*(vel_yaw_r + rho1*vel_x))/vel_x;

        // COMPUTE CONTROL I/Ps

        float acc;

        // ********************* Controller Parameters *********************
        float k_xv        = 10.0;//10.0;
        float k_xp        = 15.0;//25.0;
        float k_yv        = 10.0;//6.0;
        float k_yp        = 20.0;//9.0;

        // ************* Maximum vehicle acceleration is assumed to be 3 m/s2 *************

        acc = acc_x_d + k_xv * (vel_x_d - vel_x) + k_xp * e_sp + 0.0*v[0]; // Use 0.0*v[0] to test CTC only and 1.0*v[0] for CTC+NN

                if ( acc > 3.0 ){
                        acc  = 3.0;
                }

        // CONTROL LAWS

        g_x = m * acc - h_x;

        g_y_yaw = I_z * rr1 * (-k_yv * vel_y_s - k_yp * y_s + 0.0*v[1])/a - I_z * rr1 * h_y_s/(m*a);
		// Use 0.0*v[1] to test CTC only and 1.0*v[1] for CTC+NN

        // ***************** Solving for actual control inputs *****************

        a0 = Cf*(vel_y_s - d_s*vel_yaw_r + a*(vel_yaw_r + rho1*vel_x))/vel_x;
        b0 = -g_x - Cf + f * b * (m * g - k1 * pow(vel_x,2))/(a+b);
        c0 = g_y_yaw;

                if ( a0 == 0.0 ){
                        steer[0] = -c0/b0;
                }
                        else {
                                steer[0] = (-b0 - sqrt(pow(b0,2) - 4.0*a0*c0))/(2.0 * a0);
                        }

                        T[0] = g_x - a0 * steer[0];

				// maximum sreering angle is assumed to be 40 deg. 

				if ( steer[0] > 40.0*pi/180.0 ){
                        steer[0] = 40.0*pi/180.0;
                }
                                else if ( steer[0] < -40.0 * pi/180.0 ){
                                        steer[0] = - 40.0*pi/180.0;
                                }
                                        else {
                                                steer[0] = steer[0];
                                        }


                if ( t == 0.0 ){
                        T[0]     = 230.3;
                        steer[0] = -0.0017;
                }
                        else {
                                T[0]     = T[0];
                                steer[0] = steer[0];
                        }

        // DYNAMIC SIMULATION

        // ***** Actual Values for the Simulation *****

        m   = 1640.0+300.0;           // Curb weight (m-hat) + 140+160 kg
		I_z = 3105.0*1940.0/1640;
		Cf  = 131391.0 * 0.75;
        Cr  = 115669.0 * 0.75;
		a   = 1.193 * 0.9;
		b   = 2.78 - a;         // Wheel base = 2.78 m
        k2  = 0.49 * 1.1;       // 0.29 Toyota Prius
        k1  = 0.008 * 1.1;      // 0.0035
        f   = 0.02 * 0.9;       // P175/65R14 Low rolling resistance tires
        d_s = a + 0.91;         // 1.193 + 0.5 * 1.82;


                                // ***** FOR ADVERSE CASE *****
                                if ( t <= 50.0){
                                        Cf = Cf;
                                        Cr = Cr;
                                }
                                        else {
                                        Cf = Cf * 0.35/0.75;
                                        Cr = Cr * 0.35/0.75;
                                        }
                                // ****************************

                                if ( T[0] < -0.4 * m * g * b/(a+b) ){
                                        T[0] = -0.4 * m * g * b/(a+b);
                                }
                                        else {
                                                T[0] = T[0];
                                        }

        // Using the original unsimplified model

        g_x     = T[0]*cos(steer[0]) + Cf*((vel_y_s - d_s*vel_yaw_r
                + a*(vel_yaw_r + rho*vel_x))/vel_x - steer[0])*sin(steer[0]);
        g_y_yaw = (T[0] - f*b*(m*g - k1*pow(vel_x,2))/(a+b))*sin(steer[0]) + Cf * steer[0] * cos(steer[0]);

        rr1     = m * a/(I_z + m * d_s * a);

        h_x     =  m * (vel_y_s - rho * d_s * vel_x) * vel_yaw_r + (f * k1 * a/(a+b) - k2) * pow(vel_x,2)
                  + m * rho * vel_x * vel_y_s - m * d_s * pow(vel_yaw_r,2)
                  - (f*b*(m*g - k1*pow(vel_x,2))/(a+b))*cos(steer[0]);
        h_y_s   = -m * vel_x * vel_yaw_r - Cr*(1 - m*d_s*b/I_z) * (vel_y_s - (b+d_s)*vel_yaw_r)/vel_x
                  - m * rho * pow(vel_x,2) + rho * b * Cr * (1 - m*d_s*b/I_z)
                  - (1 + m*d_s*a/I_z) *(Cf * (vel_y_s - d_s*vel_yaw_r + a*(vel_yaw_r + rho*vel_x))/vel_x)*cos(steer[0]);
        h_yaw_r =  b*Cr*(vel_y_s - (b+d_s)*vel_yaw_r)/(a*vel_x) - rho * pow(b,2) * Cr/a
                  - (Cf * (vel_y_s - d_s*vel_yaw_r + a*(vel_yaw_r + rho*vel_x))/vel_x)*cos(steer[0]);


        acc_x[0]     = (g_x + h_x)/m;
        acc_y_s[0]   = h_y_s/m + (a * g_y_yaw)/(I_z * rr1);
        acc_yaw_r[0] = a * (h_yaw_r + g_y_yaw)/I_z;

        gg_x[0]      = g_x;
        gg_y_yaw[0]  = g_y_yaw;

}

void E( float x_d, float x, float y_s, float yaw_r, float vel_x_d, float vel_x, float vel_y_s, float vel_yaw_r,
        float e[]){

        int L = 15.0;     /* Desired longitudinal spacing */

    /* Position errors */
    e[0] = x_d - x - L;
	e[1] = -y_s;
	e[2] = -yaw_r;

    /* Velocity errors */
	e[3] = vel_x_d - vel_x;
	e[4] = -vel_y_s;
	e[5] = -vel_yaw_r;
}

int main( void )
{
   int i,j,k;
   int r1 = 7;		               // Number of neurons -- LONGIT. subnet
   int r2 = 7;		               // Number of neurons -- LATERAL subnet
   float SE,RSE;                       // Squared Error, and Root of SE
   float v[2], learn[1];
   float w1[r1], ps1[r1][4], zig1[r1][4]; // NN's weights -- LongCont Subnet
   float w2[r2], ps2[r2][4], zig2[r2][4]; // NN's Weights -- LaterErr Subnet
   float xx;
   float e[6];                         // vector of position and velocity errors
   float dt;                           // Sampling interval
   float t;                            // Current time
   float endTime;
   float acc_x[1], acc_y_s[1], acc_y, acc_yaw_r[1];// Second time derivatives of x, y_s, rel-yaw
   int totalSteps;
   float T[1];                         // Traction and/or breaking force
   float x, vel_x;                     // Longitudinal Position and Speed of the vehicle
   float y_s, vel_y_s;                 // Lateral sensor error and error rate
   float yaw_r, vel_yaw_r;             // Relative Yaw  and yaw rate
   float x_d, vel_x_d, acc_x_d;        // Desired Quantities (motion parameters of the preceding vehicle)
   float steer[1];                     // Steering angle
   float gg_x[1], gg_y_yaw[1];
   float Trac, stee;
   float L, e_sp;

    /* ************* INITIALIZING THE NEURAL SUBNETS ************* */

 /* ***************** SUBNET --- LONGITUDINAL **************** */

   /* ******** Connecting weights(w's) ******* */

		for (j=0; j<=r1-1; j++){
			xx = rand()/2147483647.0;
                        w1[j] = 0.0;
               }

     /* ********* Centers (ps's) *** LONGIT ****** */

	for (i=0; i<=r1-1; i++)
		for (j=0; j<=3; j++){
		xx = rand()/2147483647.0;
                        ps1[i][j] = -1.0 + 2.0 * xx;    //-0.50 + 1.0 * xx;
                        ps1[i][0] = 25.0 * xx + 5.0;    // desired state for longitudinal velocity
                }

     /* ******* St.deviations (zig's) *** LONGIT **** */

	for (i=0; i<=r1-1; i++)
	        for (j=0; j<=3; j++){
                        zig1[i][j] = 2.0;
		        zig1[i][0] = 8.0;
        	}


// ******************* INITIALIZING WEIGHTS -- subnet --- LATERAL *****************

      /* *********** Connecting weights(w's) *** LATERAL ******** */

        for (j=0; j<=r2-1; j++){
                xx = rand()/2147483647.0;
                w2[j] = 0.0;
        }

     /* ********* Centers (ps's) **** LATERAL ***** */

	for (i=0; i<=r2-1; i++)
		for (j=0; j<=3; j++){
		xx = rand()/2147483647.0;
                        if ( j == 0 ){
                                ps2[i][j] = 25.0 * xx + 5.0;
                        }
                                else {
		                        ps2[i][j] = -0.50 + 1.0 * xx;
                                }
                 }

     /* ******** St.deviations (zig's) *** LATERAL ***** */

	for (i=0; i<=r2-1; i++)
	   for (j=0; j<=3; j++){
		zig2[i][0] = 8.0;
                zig2[i][j] = 2.0;
	   }

 
// *************** END -- INITIALIZING THE NEURAL WEIGHTS ***************


       	FILE *fp;

	if ((fp=fopen("adversectc.dat","w"))==NULL){  
                                                      
		printf("Can't open File\n");
		exit(1);
	}

        /*  FILE *fp1;

	if ((fp1=fopen("SteerNN.dat","w"))==NULL){

		printf("Can't open File\n");
		exit(1);
	}*/


   dt = 0.0001;

   endTime = 70.0;
   totalSteps = (int)(endTime/dt);

 /* ********** initial conditions ********** */

 // Positions
        x     = 0.0;
        x_d   = 15.0;
        y_s   = 0.0;
        yaw_r = 0.0;

 // Velocities
        vel_x     = 10.0;       //10.0; //20.0 for adverse case (adhession = 0.4)
        vel_x_d   = 10.0;       
        vel_y_s   = 0.0;
        vel_yaw_r = 0.0;
        
 // Accelerations
        acc_x[0]     = 0.0;
        acc_y_s[0]   = 0.0;
        acc_yaw_r[0] = 0.0;

    /* ****************************** CONTROL LOOP ****************************** */

   for (j = 0; j <= totalSteps; j++) {

	       t = dt * j;

   /* ********************** BEGIN--SIMULATED PRECEDING VEHICLE ************************ */


               if ( t <= 3.0 ){
                        acc_x_d = 2.0 * t/3.0;
                }
                        else if ( t > 3.0 && t <= 5.0 ){
                                acc_x_d = 2.0;
                        }
                                else if ( t > 5.0 && t <= 8.0 ){
                                        acc_x_d = 2.0 - 2.0 * (t-5.0)/3.0;
                                }
                                        else if ( t > 8.0 && t <= 20.0 ){
                                                acc_x_d = 0.0;
                                        }
                                                else if ( t > 20.0 && t <=23.0 ){
                                                        acc_x_d = -2.0 * (t-20.0)/3.0;
                                                }
                                                        else if ( t > 23.0 && t <= 25.0 ){
                                                                acc_x_d = - 2.0;
                                                        }
                                                                else if ( t > 25.0 && t <=28.0 ){
                                                                        acc_x_d = -2.0 + 2.0 * (t-25.0)/3.0;
                                                                }
                                                                else if ( t > 28.0 && t <=35.0 ){
                                                                        acc_x_d = 0.0;
                                                                }
                                                                else if ( t > 35.0 && t <=38.0 ){
                                                                        acc_x_d = 2.0 * (t-35.0)/3.0;
                                                                }
                                                                else if ( t > 38.0 && t <=40.0 ){
                                                                        acc_x_d = 2.0;
                                                                }
                                                                else if ( t > 40.0 && t <=43.0 ){
                                                                        acc_x_d = 2.0 - 2.0*(t-40.0)/3.0;
                                                                }
                else if ( t > 43.0 && t <=53.0 ){
                        acc_x_d = 0.0;
                }
                        else if ( t > 53.0 && t <= 56.0 ){
                                acc_x_d = -0.8 * (t-53.0);
                        }
                                else if ( t > 56.0 && t <= 59.0 ){
                                        acc_x_d = -2.4;
                                }
                                        else if ( t > 59.0 && t <= 62.0 ){
                                                acc_x_d = 0.8 * (t-59.0) - 2.4;
                                        }
                                                  else {
                                                        acc_x_d = 0.0;
                                                  }

                                                  //acc_x_d = 0.0;

 // *********** FOR ADVERSE CASE (ADHESSION = 0.4) *************

 /*              if ( t<=53.0 ){
                        acc_x_d = 0.0;
                }
                        else if ( t > 53.0 && t <= 56.0 ){
                                acc_x_d = -0.8 * (t-53.0);
                        }
                                else if ( t > 56.0 && t <= 59.0 ){
                                        acc_x_d = -2.4;
                                }
                                        else if ( t > 59.0 && t <= 62.0 ){
                                                acc_x_d = 0.8 * (t-59.0) - 2.4;
                                        }
                                                  else {
                                                        acc_x_d = 0.0;
                                                  }     */

 // *************************************************************

                if ( t == 0.0){
                        x_d     = x_d;      // To make sure longitudinal error is equal to initial error at t=0
                        vel_x_d = vel_x_d;
                }
                        else {
                              vel_x_d = vel_x_d + acc_x_d * dt;
                              x_d     = x_d + vel_x_d * dt + acc_x_d * pow(dt,2)/2.0;
                        }

   /* ******************* SIMULATED PRECEDING VEHICLE -- END ********************* */

                              /* ******* Spacing Error ******** */
                                        L    = 15.0;
                                        e_sp = x_d - x - L;      // x_d = x_preceeding

        E( x_d, x, y_s, yaw_r, vel_x_d, vel_x, vel_y_s, vel_yaw_r, e );

       	NN( t, r1, r2, w1, w2, ps1, ps2, zig1, zig2, e, vel_x, vel_y_s, vel_yaw_r, acc_x, acc_y_s, dt,
            totalSteps, v, learn );

	control( t, v, e_sp, vel_x_d, acc_x_d, y_s, yaw_r, vel_x, vel_y_s, vel_yaw_r, acc_x, acc_y_s, acc_yaw_r, T,
                steer, gg_x, gg_y_yaw );

         /* Euler method of numerical integration to get positions and velocities */

         if ( t == 0.0){
                x         = x;
                y_s       = y_s;
                yaw_r     = yaw_r;

                vel_x     = vel_x;
                vel_y_s   = vel_y_s;
                vel_yaw_r = vel_yaw_r;
         }

                else {
                        vel_x     = vel_x     + acc_x[0]     * dt;
                        vel_y_s   = vel_y_s   + acc_y_s[0]   * dt;
                        vel_yaw_r = vel_yaw_r + acc_yaw_r[0] * dt;

                        x      = x     + vel_x     * dt     + acc_x[0] * pow(dt,2)/2.0;
                        y_s    = y_s   + vel_y_s   * dt   + acc_y_s[0] * pow(dt,2)/2.0;
                        yaw_r  = yaw_r + vel_yaw_r * dt + acc_yaw_r[0] * pow(dt,2)/2.0;
                }


                Trac     = T[0] * 14.0 * 0.0254;      // Traction and/or braking torque (to be printed)
                stee     = steer[0] * 180.0/pi;
                acc_y    = acc_y_s[0] - 2.103 * acc_yaw_r[0];

           if ( j % 1000 == 0) {
              fprintf(fp, "%2f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f \n", t, e_sp, y_s, yaw_r*180.0/pi, Trac,
              steer[0], vel_x, vel_x_d, acc_x_d, gg_x[0], gg_y_yaw[0], acc_y, learn[0]);
              //fprintf(fp, "%2f %4f %4f \n",t, e_sp, learn[0]);
              //fprintf(fp, "%2f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f \n",t, w1[0], w1[1], w1[2],
              //w1[3], w1[4], w1[5], w1[6], w2[0], w2[1], w2[2], w2[3], w2[4], w2[5], w2[6]);
           }
}
       fclose(fp);
       return 0;
}
