#include<stdio.h>
#include<math.h>
#include<stdlib.h>

//#include"relpose.c"
//#include"jacobians.c"
//#include"headMove.c"

#define pi 3.141592653589793238
#define g 9.80665


void control( float y_0, int r1, int r2, float w1[], float w2[], float ps1[r1][5], float ps2[r2][6], float zig1[r1][5],
         float zig2[r2][6], float vel_yaw, float yaw_r, float vel_yaw_r, float ss_steer, float ggg_y, int j, float endTime, float t,
         float dt, float z_y, float x_hat, float y_hat, float nu_y_hat, float x_d, float vel_x_d, float acc_x_d, float x,
         float vel_x, float y, float vel_y, float acc_x[], float acc_y[], float acc_yaw_r[], float T[], float s_steer[],
         float gg_x[], float gg_y[], float vel_y_ha[], float acc_yaw[], float v1[], float v2[]){

/* Computed torque controller */

        int i, k;
        float h_x, h_y;
        float C11, C12, C21, C22, D11, D21;
        float vel_x_hat, vel_y_hat, nu_x_hat;
 		float g_x, g_y, steer;
        float m, I_z, Cf, Cr, a, b, k1, k2, f, rho;
        float a0, b0, c0;

/* ** Model Parameters - Nominal (From SAVRIN Data-sheet and k1&k2 guessed according to the book "THEORY OF Ground Vehicles")** */

	m = 1640.0;       // Curb weight
	I_z = 3105.0;
	Cf = 131391.0;
    Cr = 115669.0;
	a = 1.193;
	b = 2.78 - a;
        k2 = 0.49;       // 0.29 Toyota Prius
        k1 = 0.008;      // 0.0035
        f = 0.02;        // P175/65R14 Low rolling resistance tires

        /* ******* ROAD PROFILE -- SUDDEN CURVATURE CHANGE***** */

        if ( t <= 5.0 ){
                rho = 0.0;
        }
                        else if ( t > 5.0 && t <= 15.0 ){
                                rho = -1.0/750.0;
                        }
                                else if ( t > 15.0 && t <= 23.0 ){
                                        rho = 1.0/540.0;
                                }
                                        else if ( t > 23.0 && t <= 32.0 ){
                                                rho = 0.0;
                                        }
                                                else if( t > 32.0 && t <= 40.0 ){
                                                        rho = 1.0/500.0;
                                                }
                                                        else {
                                                                rho = 1.0/500.0;//.0.0;
                                                        }

                /* ******* ROAD PROFILE -- SMOOTH CHANGE IN CURVATURE***** */

        if ( t <= 5.0 ){
                rho = 0.0;
        }
                else if ( t > 5.0 && t <= 6.0 ){
                                rho = -(t-5.0) * 1.0/750.0;
                }
                        else if ( t > 6.0 && t <= 15.0 ){
                                rho = -1.0/750.0;
                        }
                                else if ( t > 15.0 && t <= 16.0 ){
                                        rho = -1.0/750.0 + (t-15.0)*(1.0/540.0 + 1.0/750.0);
                                }
                                else if ( t > 16.0 && t <= 23.0 ){
                                        rho = 1.0/540.0;
                                }
                                        else if ( t > 23.0 && t <= 24.0 ){
                                                rho = (24.0-t)*1.0/540.0;
                                        }
                                        else if ( t > 24.0 && t <= 32.0 ){
                                                rho = 0.0;
                                        }
                                                else if( t > 32.0 && t <= 33.0 ){
                                                        rho = (t-32.0)*1.0/500.0;
                                                }
                                                else if( t > 33.0 && t <= 40.0 ){
                                                        rho = 1.0/500.0;
                                                }
                                                        else {
                                                                rho = 1.0/500.0;
                                                        }  

        // *************  FOR ADVERSE (ADHESSION = 0.3) CASE ***************
/*                                if ( t <= 32.0){
                                        rho = 0.0;
                                }
                                        else {
                                        rho = 1.0/500.0;
                                        }                */
// ***********************************************

              //  rho = 0.0; to try on stright roads

        // **************** ** COMPUTE CONTROLLER/OBSERVER ******************

        float acc_max, F_max, F_min;

/* **** For Full model -- These values give better estimated velocity (only when no parameter uncertainty) **** */

        float Kd_x      = 40.0;       
        float Kd_y      = 10.0;       
        float Kp_x      = 50.0;
        float Kp_y      = 40.0;       
        float Ld_y      = 0.5;        
        float Lp_y      = 0.05;       

        // *************** OBSERVER **************

        z_y = z_y + dt * (nu_y_hat + Lp_y * (y - y_hat));

       // printf("z_y=%4f \n", z_y);

        vel_x_hat = vel_x;
        vel_y_hat = z_y + Ld_y * (y - y_hat);

        //vel_y_hat = vel_y;

        // ****** ****** CONTROLLER ****** ********

        // ****** Resolved Acceleration
        nu_x_hat =  acc_x_d - Kd_x * (vel_x_hat - vel_x_d) - Kp_x * (x - x_d);
        nu_y_hat =          - Kd_y *  vel_y_hat            - Kp_y * y;

        // **************
        y_hat = y_hat + dt * vel_y_hat;
        // **************
        
                if ( nu_x_hat > 3.0 ){
                        nu_x_hat  = 3.0;
                }

        // ************************************ For the MODEL-BASED control law ****
        C11 = (k2 - f * k1) * vel_x;
        C12 = -m * rho * vel_x;
        C21 =  m * rho * vel_x;
        C22 = (Cf + Cr)/vel_x;

        D11 = 0.0;
        D21 = (a*Cf - b*Cr)*vel_yaw/vel_x;
        //************************* ***************** ******************************

        // ************************************ For the NEURAL NETWORKS control law ****

        float lambda = 0.5;   
        float s1, s2, s1_hat, s2_hat;
        float ip1[5], ip2[6], f1[r1], f2[r2];

        s1  = (vel_x - vel_x_d) + lambda * (x - x_d);
        s2  = 2.0 * (y - y_0)/dt - 0.0 - vel_y_hat + lambda * (2.0 * y - 0.0 - y_hat);
        y_0 = y;

        s1_hat =  s1;
        s2_hat =  vel_y_hat - 0.0  + lambda * (2.0 * y - 0.0 - y_hat);

        ip1[0] = rho * vel_x;
        ip1[1] = vel_x;
        ip1[2] = vel_y_hat;
        ip1[3] = sin(ss_steer);
        ip1[4] = cos(ss_steer);

        ip2[0] = rho * vel_x;
        ip2[1] = vel_x;
        ip2[2] = vel_y_hat;
        ip2[3] = sin(ss_steer);
        ip2[4] = cos(ss_steer);
        ip2[5] = vel_yaw;

        for (i=0; i<=r1-1; i++){
                f1[i] = 0.0;
                for (k=0; k<=4; k++){
                        f1[i] = f1[i] + exp(-pow((ip1[k] - ps1[i][k]),2)/pow(zig1[i][k],2));
                }
                //printf("f[%d]=%f\n",i,f[i]);
        }

        for (i=0; i<=r2-1; i++){
                f2[i] = 1.0;
                for (k=0; k<=5; k++){
                        f2[i] = f2[i] * exp(-pow((ip2[k] - ps2[i][k]),2)/pow(zig2[i][k],2));
                }
                //printf("f[%d]=%f\n",i,f[i]);
        }

        for (i=0; i<=r2-1; i++){
                f2[i] = 0.0;
                for (k=0; k<=5; k++){
                        f2[i] = f2[i] + exp(-pow((ip2[k] - ps2[i][k]),2)/pow(zig2[i][k],2));
                }
                //printf("f[%d]=%f\n",i,f[i]);
        }

// PARAMETERS
// **********
        float Lambda1, Lambda2, kapp1, kapp2;
        float w01[r1], w02[r2];

        Lambda1 = 50.0;
        Lambda2 = 20.0;
        kapp1   = 0.001;      kapp2   = 0.001;

                for (i=0; i<=r1-1; i++){
                        w01[i] = 0.0;
                }
                for (i=0; i<=r2-1; i++){
                        w02[i] = 0.0;
                }

        for (i=0; i<=r1-1; i++){
                w1[i] = w1[i] + dt * (-s1 * f1[i]/m + kapp1 * (w01[i] - w1[i])) * Lambda1;
                //printf("w[%d][2]=%f\n",i,w[i][2]);
        }

        for (i=0; i<=r2-1; i++){
                w2[i] = w2[i] + dt * (-s2 * f2[i]/m + kapp2 * (w02[i] - w2[i])) * Lambda2;
                //printf("w[%d][2]=%f\n",i,w[i][2]);
        }

                v1[0] = 0.0;
                for (i=0; i<=r1-1; i++){
                        v1[0] = v1[0] + w1[i] * f1[i];
                        //printf("v1=%f\n",v1);
    		}

                v2[0] = 0.0;
                for (i=0; i<=r2-1; i++){
                        v2[0] = v2[0] + w2[i] * f2[i];
                        //printf("v2=%f\n",v2);
    		}

        //**************************************************************************

        // ****** ** Control Laws ** ******
        // ********* Longitudinal *********
        g_x = m * nu_x_hat + C11 * vel_x_hat + C12 * vel_y_hat + D11;
        g_x = m * nu_x_hat + v1[0];

        gg_x[0] = g_x;

        // ****** Lateral ****** ******
        g_y = m * nu_y_hat + C21 * vel_x_hat + C22 * vel_y_hat + D21;
        g_y = m * nu_y_hat + v2[0];

        gg_y[0] = g_y;

        // ***********************  *******************************  ***************

        a0 = (vel_y_hat + a * vel_yaw)/vel_x;
        b0 = (g_x + Cf + f * m * g * b/(a+b) + f * a * k1 * pow(vel_x,2)/(a+b))/Cf;
        c0 = g_y/Cf;

                if ( a0 == 0.0 ){
                        steer = c0/b0;
                }
                        else {
                                steer = (b0 - sqrt(pow(b0,2) - 4.0*a0*c0))/(2.0 * a0);
                        }

                        T[0] = g_x - Cf * (a0 - steer)* steer + f*m*g;


                if ( steer > 40.0*pi/180.0 ){
                        steer = 40.0*pi/180.0;
                }
                        else if ( steer < -40.0 * pi/180.0 ){
                                steer = - 40.0*pi/180.0;
                        }
                                else {
                                        steer = steer;
                                }
                        

        s_steer[0] = steer;

        if ( t == 0.0 ){
                T[0] = 200.0;
                }
                else {
                        T[0] = T[0];
                }

        // **************** *** DYNAMIC SIMULATION *** ***************

        // ***** Actual Values for the Simulation *****

        m   = 1640.0   + 300.0;             // Curb weight (m-hat) + 4 X 75 kg
		I_z = 3105.0   * 1940.0/1640.0;     // 3105 * 2020/1640
		Cf  = 131391.0 * 0.85;
        f   = 0.0;

        // *************************** Practical bounds for control inputs ******************************

                if ( steer > 40.0*pi/180.0 ){
                        steer = 40.0*pi/180.0;
                }
                                else if ( steer < -40.0 * pi/180.0 ){
                                        steer = - 40.0*pi/180.0;
                                }
                                        else {
                                                steer = steer;
                                        }

        acc_max = 3.0;           
        F_max   = 1760.0*3.0; 
        F_min   = -b*m*g/(a+b);    

        if ( T[0] > F_max ){
                T[0] = F_max;
        }
               else if ( T[0] < F_min ){
                        T[0] = F_min;
                }
                        else{
                                T[0] = T[0];
                        }

        // ********************************************************************************************
        float alpha[4], sgn_alpha[4];

        alpha[0] = atan2(vel_y + a*vel_yaw, vel_x - 0.75  * vel_yaw) - steer;
        alpha[1] = atan2(vel_y + a*vel_yaw, vel_x + 0.75  * vel_yaw) - steer;
        alpha[2] = atan2(vel_y - b*vel_yaw, vel_x - 0.767 * vel_yaw);
        alpha[3] = atan2(vel_y - b*vel_yaw, vel_x + 0.767 * vel_yaw);
        
        for (i=0; i<=3; i++){
                if ( alpha[i] >= 0) {
                        sgn_alpha[i] = 1.0;
                }
                        else {
                                sgn_alpha[i] = -1.0;
                        }
        }

        // ******* FOR ADVERSE CASE *******
        /*                        if ( t <= 28.0){
                                        Cf = Cf;
                                        Cr = Cr;
                                }
                                        else {
                                        Cf = Cf * 0.35/0.85;
                                        Cr = Cr * 0.35;
                                        }
                                // ****************************

                                if ( T[0] < -0.4 * m * g * b/(a+b) ){
                                        T[0] = -0.4 * m * g * b/(a+b);
                                }
                                        else {
                                                T[0] = T[0];
                                        }       */
        // *********************************

        float F_xf, F_xr, F_yf, F_yr, F_x_v, F_y_v, F_x_r, F_y_r;


        F_yf = - Cf*alpha[0]/2.0 - Cf*alpha[1]/2.0;
        F_yr = - Cr*alpha[2]/2.0 - Cr*alpha[3]/2.0;

        F_xf = T[0] - f*b*(m*g - k1*pow(vel_x,2))/(a+b);
        F_xr = - f * a * (m * g - k1 * pow(vel_x,2))/(a+b);

        F_x_v = F_xr + F_xf * cos(steer) - F_yf * sin(steer) - k2 * pow(vel_x,2);
        F_y_v = F_yr + F_xf * sin(steer) + F_yf * cos(steer);

        F_x_r = F_x_v * cos(yaw_r) - F_y_v * sin(yaw_r);
        F_y_r = F_y_v * cos(yaw_r) + F_x_v * sin(yaw_r);


        acc_x[0]     = (F_x_r + m * rho * vel_x * vel_y)/m;
        acc_y[0]     = (F_y_r - m * rho * vel_x * vel_x)/m;

        acc_yaw[0]   = b*Cr*(vel_y - b*vel_yaw)/(I_z*vel_x) + a*((T[0] - f*b*(m*g - k1*pow(vel_x,2))/(a+b))*sin(steer)
                        - Cf*((vel_y + a*vel_yaw)/vel_x - steer)*cos(steer))/I_z;

        vel_y_ha[0]  = vel_y_hat;


        acc_yaw_r[0] = b*Cr*(vel_y - b*vel_yaw_r)/(I_z*vel_x) - rho*pow(b,2)*Cr/I_z + a*((T[0] - f*b*(m*g - k1*pow(vel_x,2))/(a+b))*sin(steer)
                        - Cf*((vel_y + a*vel_yaw)/vel_x - steer)*cos(steer))/I_z;
}


int main( void )
{
   int i,j;
   float dt;                           // Sampling interval
   float t;                            // Current time
   float endTime;
   float acc_x[1], acc_y[1], acc_yaw_r[1], acc_yaw[1]; // Second time derivatives of x, y, rel-yaw
   int totalSteps;
   float T[1];                         // Traction and/or breaking force
   float x;                            // Longitudinal position of the vehicle
   float vel_x;                        // Longitudinal Speed of the vehicle
   float y, y_0;                       // Lateral sensor error
   float yaw_r;                        // Relative yaw
   float vel_y;                        // Lateral sensor error rate
   float vel_yaw, vel_yaw_r;           // Yaw rate
   float x_d, x_p;                     // Desired/preceding-vehicle Position
   float vel_x_d;                      // Desired Velocity
   float acc_x_d;                      // Desired Acceleration
   float vel_x_d0;                     // Initial desired velocity
   float s_steer[1];                   // Steering angle
   float gg_x[1], gg_y[1], v1[1], v2[1];
   float Trac, stee, yaw_rr;
   float vel_xx, vel_x_dd;
   float z_y;
   float x_hat, y_hat, nu_y_hat;
   float e_x, e_y;
   float ggg_y, ss_steer;
   float vel_y_ha[0];
   float acc_y0, jerk;

   int r1 = 40;		                  // Number of neurons -- LONGIT. subnet
   int r2 = 40;		                  // Number of neurons -- LATERAL subnet
   float w1[r1], ps1[r1][5], zig1[r1][5]; // SMxF'sNN's weights -- LongCont Subnet
   float w2[r2], ps2[r2][6], zig2[r2][6]; // SMxF'sNN's Weights -- LaterErr Subnet
   float xx;

    /* ************* INITIALIZING THE NEURAL SUBNETS ************* */

 /* ***************** SUBNET --- LONGIT. ERROR **************** */

   /* ********* Connecting weights(w's) ******** */

		for (j=0; j<=r1-1; j++){
			xx = rand()/2147483647.0;
                        w1[j] = 0.0;
               }

   /* ********* Centers (ps's) *** LONGIT ****** */

	for (i=0; i<=r1-1; i++){
		xx = rand()/2147483647.0;
                ps1[i][0] = 0.1 - 0.1 * xx;   // 0.1 > road yaw rate > 0
                ps1[i][1] = 25.0 * xx + 5.0;  // 30  > long. velocity > 5
                ps1[i][2] = -0.5 + 1.0 * xx;  // 0.5 > lat. velocity (estimated) > -0.5
                ps1[i][3] = -0.1 + 0.2 * xx;  // 0.1 > sin(steer) > -0.1
                ps1[i][4] = 1.0 - 0.5 * xx;   // 1.0 > cos(steer) > 0.5
        }

     /* ******* St.deviations (zig's) *** LONGIT **** */

	for (i=0; i<=r1-1; i++)
	        for (j=0; j<=4; j++){
                        zig1[i][j] = 2.0;
		        zig1[i][1] = 8.0;
        	}

// ******************* INITIALIZING WEIGHTS -- subnet --- LATERAL ERROR *****************

      /* *********** Connecting weights(w's) *** LATERAL ******** */

        for (j=0; j<=r2-1; j++){
                xx = rand()/2147483647.0;
                w2[j] = 0.0;
        }

     /* ********** Centers (ps's) **** LATERAL ********* */

	for (i=0; i<=r2-1; i++){
                xx = rand()/2147483647.0;
                ps2[i][0] = 0.1 - 0.1 * xx;   // 0.1 > road yaw rate > 0
                ps2[i][1] = 25.0 * xx + 5.0;  // 30  > long. velocity > 5
                ps2[i][2] = -0.5 + 1.0 * xx;  // 0.5 > lat. velocity (estimated) > -0.5
                ps2[i][3] = -0.1 + 0.2 * xx;  // 0.1 > sin(steer) > -0.1
                ps2[i][4] = 1.0 - 0.5 * xx;   // 1.0 > cos(steer) > 0.5
                ps2[i][5] = -0.5 + 1.0 * xx;  // 0.5 > yaw rate   > -0.5
        }

     /* ******** St.deviations (zig's) *** LATERAL ***** */

	for (i=0; i<=r2-1; i++)
	   for (j=0; j<=5; j++){
                zig2[i][j] = 2.0;
                zig2[i][1] = 8.0;
	   }
// *************** END -- INITIALIZING THE NEURAL WEIGHTS ***************


       	FILE *fp;

	if ((fp=fopen("resultNN.dat","w"))==NULL){

		printf("Can't open File\n");
		exit(1);
	}

/*        FILE *fp1;

	if ((fp1=fopen("SteerNN.dat","w"))==NULL){

		printf("Can't open File\n");
		exit(1);
	}   */


   dt = 0.0005;

   endTime = 48.0;
   totalSteps = (int)(endTime/dt);

 /* *********** initial conditions *********** */

        ggg_y    = 0.0;
        ss_steer = 0.0;
 // Positions
        x     = 0.0;
        x_p   = 15.0;

//        x_p   = 35.0;

        y     = 0.0;
        y_0   = 0.0;
        yaw_r = 0.0;

 // Velocities
        vel_x     = 18.0;
        vel_x_d   = 18.0;
        vel_x_d0  = 18.0;

 // Velocities for the ADVERSE case
/*        vel_x     = 21.8;//20.0;
        vel_x_d   = 21.8;//20.0;
        vel_x_d0  = 21.8;//20.0;*/

/*        vel_x     = 15.0;
        vel_x_d   = 20.0;
        vel_x_d0  = 20.0;      */

        vel_y     = 0.0;
        vel_yaw_r = 0.0;
        vel_yaw   = 0.0;
        
 // Accelerations
        acc_x[0]     = 0.0;
        acc_y[0]     = 0.0;
        acc_yaw_r[0] = 0.0;
        acc_y0       = 0.0;

 // Observer parameters

        z_y = vel_y;

        x_hat    = x;
        y_hat    = y;
        nu_y_hat = acc_y[0];

   /* ****************************** CONTROL LOOP ***************************** */

   for (j = 0; j <= totalSteps; j++) {

	       t = dt * j;

   /* ******* Varying accelerations and curvatures***** SIMULATED PRECEDING VEHICLE -- ACCELERATION PROFILE ***** */

                if ( t <= 4.0 ){
                        acc_x_d = 0.0;
                }
                        else if ( t > 4.0 && t <= 10.0 ){
                                acc_x_d = -2.0/6.0;
                        }
                                else if ( t > 10.0 && t <= 20.0 ){
                                        acc_x_d = 0.0;
                                }
                                        else if ( t > 20.0 && t <= 20.5 ){
                                                acc_x_d = (t - 20.0)*2.2;
                                        }
                                        else if ( t > 20.5 && t <= 24.0 ){
                                                acc_x_d = 1.36;
                                        }
                                        else if ( t > 24.0 && t <= 25.0 ){
                                                        acc_x_d = 1.36 - 1.36*(t-24.0);
                                                }
                                                else if ( t > 25.0 && t <= 30.0 ){
                                                        acc_x_d = 0.0;
                                                }
                                                else if ( t > 30.0 && t <= 33.0 ){
                                                        acc_x_d = -0.8 * (t-30.0);
                                                }
                                                        else if ( t > 33.0 && t <= 36.0 ){
                                                                acc_x_d = -2.4;
                                                        }
                                                                else if ( t > 36.0 && t <= 39.0 ){
                                                                        acc_x_d = 0.8 * (t-36.0) - 2.4;
                                                                }

                                                                        else {
                                                                                acc_x_d = 0.0;
                                                                        }

 // *********** FOR ADVERSE CASE (ADHESSION = 0.3) *************

 /*              if ( t<=30.0 ){
                        acc_x_d = 0.0;
                }
                        else if ( t > 30.0 && t <= 33.0 ){
                                acc_x_d = -0.8 * (t-30.0);
                        }
                                else if ( t > 33.0 && t <= 36.0 ){
                                        acc_x_d = -2.4;
                                }
                                        else if ( t > 36.0 && t <= 39.0 ){
                                                acc_x_d = 0.8 * (t-36.0) - 2.4;
                                        }
                                                else {
                                                        acc_x_d = 0.0;
                                                }  */

   // *************************************************************
 // acc_x_d =0.0;
   /* ************************************************************************************************************ */

                if ( t == 0.0){
                        x_p     = x_p;      // To make sure longitudinal error is equal to initial error at t=0
                        vel_x_d = vel_x_d;
                }
                        else {
                              vel_x_d = vel_x_d + acc_x_d * dt;
                              x_p     = x_p + vel_x_d * dt + acc_x_d * pow(dt,2)/2.0;
                        }

               x_d = x_p - 15.0;

        control( y_0, r1, r2, w1, w2, ps1, ps2, zig1, zig2, vel_yaw, yaw_r, vel_yaw_r, ss_steer, ggg_y, j, endTime, t, dt, z_y,
                x_hat, y_hat, nu_y_hat, x_d, vel_x_d, acc_x_d, x, vel_x, y, vel_y, acc_x, acc_y, acc_yaw_r, T, s_steer,
                gg_x, gg_y, vel_y_ha, acc_yaw, v1, v2 );

                ggg_y    = gg_y[0];
                ss_steer = s_steer[0];

         /* ******  Euler method to get positions and velocities  ****** */

         if (t == 0.0){
                x         = x;
                y         = y;
                yaw_r     = yaw_r;

                vel_x     = vel_x;
                vel_y     = vel_y;
                vel_yaw_r = vel_yaw_r;
                vel_yaw   = vel_yaw;
         }

                else {
                        vel_x     = vel_x     + acc_x[0]     * dt;
                        vel_y     = vel_y     + acc_y[0]     * dt;
                        vel_yaw_r = vel_yaw_r + acc_yaw_r[0] * dt;
                        vel_yaw   = vel_yaw   + acc_yaw[0]   * dt;

                        x      = x     + vel_x     * dt + acc_x[0]     * pow(dt,2)/2.0;
                        y      = y     + vel_y     * dt + acc_y[0]     * pow(dt,2)/2.0;
                        yaw_r  = yaw_r + vel_yaw_r * dt + acc_yaw_r[0] * pow(dt,2)/2.0;
                }

                Trac     = T[0] * 14.0 * 0.0254;        // Traction and/or braking torque (to be printed)
                stee     = s_steer[0] * 180.0/pi;
                yaw_rr   = yaw_r * 180.0/pi;

                e_x = x - x_p + 15.0;                   // e_x = x - x_d = x - (x_p - L)
                e_y = y - 0.0;

                jerk     = (acc_y[0] - acc_y0)/dt;
                acc_y0   =  acc_y[0];

           
           if ( j % 1000 == 0) {
              fprintf(fp, "%4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f %4f \n",
              x, e_x*100, e_y*100, vel_yaw, Trac, s_steer[0], vel_x_d, yaw_rr, acc_x_d, t, jerk, acc_y[0], vel_y,
              vel_y_ha[0], v1[0], v2[0], w1[0]*10, w1[13]*10, w1[19]*10, w1[39]*10, w2[0], w2[9], w2[19], w2[39]);
           }
          // fprintf(fp, "%4f %4f \n", t, -e_x);
}
       fclose(fp);
       return 0;
}

