#include<stdio.h>
#include<math.h>
#include<stdlib.h>

//#include"relpose.c"
//#include"jacobians.c"
//#include"headMove.c"

#define pi 3.141592653589793238
#define g 9.80665



int main( void )
{
   int r = 10;										/* No of neurons in the RBFNN */
   int i,j,k;									
   float dt;                                        /* sampling interval */
   float t;                                         /* current time */
   float endTime;
   double q1, q2;									/* Robot joint angles */
   double q1_d, q2_d, q1_d0, q2_d0;
   double q1_hat, q2_hat;
   double vel_q1, vel_q2;							/* Joint velocities */
   double vel_q1_d, vel_q2_d, vel_q1_d0, vel_q2_d0;
   double vel_q1_hat, vel_q2_hat;
   double acc_q1, acc_q2;							/* Joint accelerations */
   double acc_q1_d, acc_q2_d;
   int totalSteps;
   double z1, z2;
   double nu[2], v[2], T[2];


   float w[r][2], ps[r][4], zig[r][4]; /* RBF NN wights */
   float xx;
   double q1_0, q2_0;
   double e1, e2;
   
	FILE *fp;

	
	if ((fp=fopen("data.dat.dat","w"))==NULL){
	
		printf("Can't open File\n");
		exit(1);
	}

   dt = 0.01;
   endTime = 20.0;
   totalSteps = (int)(endTime/dt);
   
   /* initial conditions */
     
   /* angular position */
  
   q1 = 0.5;    //1.0;
   q2 = 3.0;
   q1_d0  = q1;    q2_d0  = q2;
   q1_hat = q1;    q2_hat = q2;
   q1_0   = q1;    q2_0   = q2;

   /* initial velocity */
   vel_q1     = 0.0;
   vel_q2     = 0.0;
   vel_q1_d0  = 0.0;            vel_q2_d0  = 0.0;
   vel_q1_hat = vel_q1;         vel_q2_hat = vel_q2;

   z1 = 0;      z2 = 0;

     /* Initializing weights(w's) */
	for (i=0; i<=r-1; i++)
		for (j=0; j<=1; j++){
			xx = rand()/2147483647.0;
			w[i][j] = -0.50 + 1.0 * xx;
			//fprintf(fp,"w[%d][%d]=%f \n",i,j,w[i][j]);
    }
    
     /* Initializing weights(ps's) */
   
	for (i=0; i<=r-1; i++)
		for (j=0; j<=3; j++){
		xx = rand()/2147483647.0;
		ps[i][j] = -1.0 + 2.0 * xx;
		//fprintf(fp,"%f\n",ps[i][j]);
    }

     /* Initializing weights(zig's) */
   
	for (i=0; i<=r-1; i++)
	   for (j=0; j<=3; j++){
	   xx = rand()/2147483647.0;
                zig[i][j] = 3.0;
                //zig[i][j] = -2.0 + 4.0 * xx;
		//fprintf(fp,"%f\n",zig[i][j]);
	}
    	    	    
    	    	    
    /* ****************************** CONTROL LOOP ******************************* */
    
   for (k = 0; k <= (totalSteps)-1 ; k++) {

        t = dt * k;

        /* ************ DESIRED TRAJECTORY *********** */

    	   q1_d = 0.5 * cos(pi/2.0*t);
    	   q2_d = 3.0 * cos(t);

           //fprintf(fp, "%4f %4f %4f \n",t,q1_d,q2_d);

           vel_q1_d  = (q1_d - q1_d0)/dt;                vel_q2_d = (q2_d - q2_d0)/dt;
           q1_d0     = q1_d;                             q2_d0    = q2_d;

           acc_q1_d  = (vel_q1_d - vel_q1_d0)/dt;       acc_q2_d  = (vel_q2_d - vel_q2_d0)/dt;
           vel_q1_d0 = vel_q1_d;                        vel_q2_d0 = vel_q2_d;

        /* ************ OBSERVER ************ */
// PARAMETERS
// **********
        float Ld1 = 2.0;               float Ld2 = 2.0;
        float Lp1 = 0.2;               float Lp2 = 0.2;

        Ld1 = Ld2 = 1.0; Lp1 = Lp2 = 0.1;

        float Kd1 = 15.0;               float Kd2 = 15.0;
        float Kp1 = 40.0;               float Kp2 = 40.0;

        Kd1 = 50.0;
        Kd2 = 50.0;
        Kp1 = 5000.0;
        Kp2 = 5000.0;

        nu[0] = acc_q1_d - Kd1 * (vel_q1_hat - vel_q1_d) - Kp1 * (q1 - q1_d);
        nu[1] = acc_q2_d - Kd2 * (vel_q2_hat - vel_q2_d) - Kp2 * (q2 - q2_d);

        z1 = z1 + dt * (nu[0] + Lp1 * (q1 - q1_hat));
        z2 = z2 + dt * (nu[1] + Lp2 * (q2 - q2_hat));

        vel_q1_hat = z1 + Ld1 * (q1 - q1_hat);
        vel_q2_hat = z2 + Ld2 * (q2 - q2_hat);

        /* ************ NN & CONTROL LAW *********** */

        float  m[2][2];
        double f[r], s[2], M[2][2], w0[r][2];

// PARAMETER
// *********
        float lambda = 0.40; 

        w0[0][0] = 1.0; w0[1][0] = 1.0; w0[2][0] = 1.0; w0[3][0] = 1.0; w0[4][0] = 1.0;
        w0[5][0] = 1.0; w0[6][0] = 1.0; w0[7][0] = 1.0; w0[8][0] = 1.0; w0[9][0] = 1.0;
        w0[0][1] = 1.0; w0[1][1] = 1.0; w0[2][1] = 1.0; w0[3][1] = 1.0; w0[4][1] = 1.0;
        w0[5][1] = 1.0; w0[6][1] = 1.0; w0[7][1] = 1.0; w0[8][1] = 1.0; w0[9][1] = 1.0;

        m[0][0] = 9.77 + 2.02 * cos(q2);    m[1][1] = 1.12;
        m[0][1] = m[1][0] = 1.26 + 1.01 * cos(q2);

        M[0][0] = m[1][1]/(m[0][0]*m[1][1] - m[1][0]*m[1][0]);  M[1][1] = m[0][0]/(m[0][0]*m[1][1] - m[1][0]*m[1][0]);
        M[0][1] = M[1][0] = - m[1][0]/(m[0][0]*m[1][1] - m[1][0]*m[1][0]);

        s[0] = 2.0 * (q1 - q1_0)/dt - vel_q1_d - vel_q1_hat + lambda * (2.0 * q1 - q1_d - q1_hat);
        q1_0 = q1;
        s[1] = 2.0 * (q2 - q2_0)/dt - vel_q2_d - vel_q2_hat + lambda * (2.0 * q2 - q2_d - q2_hat);
        q2_0 = q2;

        /* ************ WEIGHT UPDATE *********** */

                        double ip[4];

                        ip[0] = q1;
			ip[1] = q2;
			ip[2] = vel_q1_d;
			ip[3] = vel_q2_d;

        for (i=0; i<=r-1; i++){
                f[i] = 1.0;
                for (j=0; j<=3; j++)
                        f[i] = f[i] * exp(-pow((ip[j] - ps[i][j]),2)/pow(zig[i][j],2));
                        //printf("%f\n",f[i]);
        }

        /* ************** WEIGHT UPDATE LAW ************** */

// PARAMETERS
// **********
        float Lambda = 2000.0;
        float kapp   = 0.01;

        for (i=0; i<=r-1; i++)                          // NOTE: this loop-form can be valid only for i = 0, 1
                for (j=0; j<=1; j++){
                        w[i][j] = w[i][j] + dt * (-f[i] * (s[j] * M[j][j] + s[1-j] * M[1-j][j])
                        + kapp * (1.0 * w0[i][j] - w[i][j])) * Lambda;
                //fprintf(fp, "w[%d][%d]=%f\n",i,j,w[i][j]);
                }

        /* CONTROL LAW -- Calculate the torques */

		for (i=0; i<=1; i++){
			v[i] = 0.0;
				for (j=0; j<=r-1; j++)
					v[i] = v[i] + w[j][i] * f[j];
					//printf("v[%d]=%f\n",i,v[i]);
    		}

              /*  for (i=0; i<=1; i++){
                        T[i] = m[i][i] * nu[i] + m[i][1-i] * nu[1-i] + v[i];
                }  */

        /* ************ DYNAMIC SIMULAITON *********** */

        float C[2][2], G[2], F[2], h[2];

        C[0][0] = -1.01 * sin(q2) * vel_q2;     C[0][1] = -1.01 * sin(q2) * (vel_q1 + vel_q2);
        C[1][0] = 1.01 * sin(q2) * vel_q1;      C[1][1] = 0.0;

        G[0] = g * (8.1 * sin(q1) + 1.13 * sin(q1 + q2));
        G[1] = g * (1.13 * sin(q1+q2));

        F[0] = vel_q1 + 10.0 * cos(3.0 * q1);
        F[1] = 1.2 * vel_q2 + 5.0 * sin(2.0 * q2);

        h[0] = C[0][0] * vel_q1 + C[0][1] * vel_q2 + G[0] + F[0];
        h[1] = C[1][0] * vel_q1 + C[1][1] * vel_q2 + G[1] + F[1];

        // -------------------------

        for (i=0; i<=1; i++){
                        T[i] = m[i][i] * nu[i] + m[i][1-i] * nu[1-i];// + v[i];//h[i];
                }

        // -------------------------

        acc_q1 = M[0][0] * (T[0] - h[0]) + M[0][1] * (T[1] - h[1]);
        acc_q2 = M[1][0] * (T[0] - h[0]) + M[1][1] * (T[1] - h[1]);

        vel_q1 = vel_q1 + acc_q1 * dt;
        vel_q2 = vel_q2 + acc_q2 * dt;

        q1 = q1 + vel_q1 * dt + acc_q1 * pow(dt,2)/2.0;
        q2 = q2 + vel_q2 * dt + acc_q2 * pow(dt,2)/2.0;

        e1 = q1 - q1_d;
        e2 = q2 - q2_d;

        fprintf(fp, "%4f %4f %4f %4f %4f %4f %4f %4f %4f \n", t, q1_d, q1, q2_d, q2, e1, e2, v[0], v[1]);

}
       fclose(fp);
       return 0;
}

