#include<stdio.h>
#include<math.h>
#include<stdlib.h>

//#include"relpose.c"
//#include"jacobians.c"
//#include"headMove.c"

#define pi 3.141592653589793238
#define g 9.80665

/* Normal RBF sum type with all the weights are updated */ 

void RBFNN( float w[4][10], float ps[10][12], float zig[10][12], double e[], double theta_p, double theta_t, 
			double theta_l, double theta_r, double vel_p, double vel_t, double vel_l, double vel_r, double acc_p[], 			double acc_t[], double acc_l[], double acc_r[], float dt, double v[] ){
			
			
			float ip[12];  /* i/p s to th NN */
			int r = 10;
			int i,j,p;
			float f[10];  /* o/p s from RBF's neurons */
			float e_f[4];
			float ss = 5.0/60.0;
			float pp = 7.0/60.0;
			float EE, E;
			float df_dzig[10][12];
			float df_dps[10][12];
			float aa[10];
			float l1 = 0.1;
			float l2 = 0.1;
			float l3 = 0.1;
			float k_w = 0.001;
			float k_ps = 0.001;
			float k_zig = 0.001;
			
			
	FILE *fp;
	
	if ((fp=fopen("wsave.dat","w"))==NULL){
	
		printf("Can't open File\n");
		exit(1);
	}
		
					
			ip[0] = theta_p;
			ip[1] = theta_t;
			ip[2] = theta_l;
			ip[3] = theta_r;
			ip[4] = vel_p;
			ip[5] = vel_t;
			ip[6] = vel_l;
			ip[7] = vel_r;
			ip[8] = acc_p[0];
			ip[9] = acc_t[0];
			ip[10] = acc_l[0];
			ip[11] = acc_r[0];
			
	/* Calculating f_i ; i = 1, 2, ........r, the activations of the hidden neurons */
			
		for (i=0; i<=r-1; i++){
			f[i] = 0.0;
				for (j=0; j<=11; j++)
					f[i] = f[i] + exp(-pow((ip[j] - ps[i][j]),2)/pow(zig[i][j],2));
					//printf("%f\n",f[i]);
    		}
    		
    /* Calculating e_f, the filtered error signal to the neural net */
    
    		for (i=0; i<=3; i++){
    			e_f[i] = ss*e[i] + pp*e[i+4];
    			//printf("%f\n",e_f[i]);
			}
			
	/* Calculating Euclidan norm, ||E|| = E */
		
		EE = 0.0;
		for (i=0; i<=7; i++){
			EE = EE + pow(e[i],2);
		}
    	
    	E = sqrt(EE);
    	//printf("%f\n",E);
    	
    /* Calculating daba(f_i)/daba(ps_i_j), the derivatives for the weight update law */ 	
		for (i=0; i<=r-1; i++)
			for (j=0; j<=11; j++){
				df_dps[i][j] = 2.0 * (ip[j] - ps[i][j])/pow(zig[i][j],2) * exp(-pow((ip[j] - ps[i][j]),2)											/pow(zig[i][j],2));
				//fprintf(fp,"%f\n",df_dps[i][j]);
    		}
    	
    /* Calculating daba(f_i)/daba(zig_i_j) */ 	
		for (i=0; i<=r-1; i++)
			for (j=0; j<=11; j++){
				df_dzig[i][j] = 2.0 * pow((ip[j] - ps[i][j]),2)/pow(zig[i][j],3) * exp(-pow((ip[j] - ps[i][j]),2)								/pow(zig[i][j],2));
				//fprintf(fp,"%f\n",df_dzig[i][j]);
    		}
    		
    /* Updating weights */
    
    /* Calculating e_f.w matrix product */
    
		for (i=0; i<=r-1; i++){
			aa[i] = 0.0;
				for (j=0; j<=3; j++)
					aa[i] = aa[i] + e_f[j] * w[j][i];
					//printf("%f\n",aa[i]);
    		}

    /* Updating ps[10][12], the center states */

		for (i=0; i<=r-1; i++)
				for (j=0; j<=11; j++){
					ps[i][j] = ps[i][j] + l2 * dt * (aa[i] * df_dps[i][j] - k_ps * E * ps[i][j]);
					//fprintf(fp, "%f\n",ps[i][j]);
    			}

    /* Updating zig[10][12], the widths or the standard deviations */

		for (i=0; i<=r-1; i++)
				for (j=0; j<=11; j++){
					zig[i][j] = zig[i][j] + l3 * dt * (aa[i] * df_dzig[i][j] - k_zig * E * zig[i][j]);
					//fprintf(fp, "zig[%d][%d]=%f\n",i,j,zig[i][j]);
    			}
    			
    /* Updating w[4][10], the connecting weights */

		for (i=0; i<=3; i++)
				for (j=0; j<=r-1; j++){
					w[i][j] = w[i][j] + l1 * dt * (e_f[i] * f[j] - k_w * E * w[i][j]);
					//fprintf(fp, "w[%d][%d]=%f\n",i,j,w[i][j]);
    			}
    			
    /* Calculating RBF's NN's signal vector v[4] to counteract head's uncertainties */

    /* Calculating f[10] for updated weights */

		for (i=0; i<=r-1; i++){
			f[i] = 0.0;
				for (j=0; j<=11; j++)
					f[i] = f[i] + exp(-pow((ip[j] - ps[i][j]),2)/pow(zig[i][j],2));
					//fprintf(fp, "f[%d]=%f\n",i,f[i]);
    		}
    		
    /* Calculating v[4] */

		for (i=0; i<=3; i++){
			v[i] = 0.0;
				for (j=0; j<=r-1; j++)
					v[i] = v[i] + w[i][j] * f[j];
					//printf("v[%d]=%f\n",i,v[i]);
    		}
    		    		
}

void ctc( double v[], double e[], double acc_pd, double acc_td, double acc_vd, double theta_p, double theta_t, 
		  double theta_l, double theta_r, double vel_p, double vel_t, double vel_l, double vel_r, double acc_p[], 		  double acc_t[], double acc_l[], double acc_r[], float T_p[], float T_t[], float T_l[], float T_r[] ) {

/* The control algorithm */

	float k_p = 15.0;
	float k_v;
	
	double u_p;
	double u_t;
	double u_l;
	double u_r;
			
	/* Constants in the Robot Head dynamic model */

	double k1 = 0.0114651;
	double k2 = 0.0131155;
	double k3 = 0.0013466;
	double k4 = 0.0026331;
	double k5 = 0.0002025;
	double k6 = 0.0000144;
	double k7 = -0.000108;
	double k8 = 0.000038477;
	double k9 = 0.021082;
	double k10 = -0.001440;
	
	double m11, m12, m13, m14, m21, m22, m31, m33, m41, m44;
	double D_m;
	double M[4][4];
	double I[4][4];
	int i,j;
	double h_p, h_t, h_l, h_r;
			
    //k_v = sqrt(k_p);
    k_v = k_p;
	
/* Control with the NN */

/*	u_p = acc_pd + k_v * e[4] + k_p * e[0] + v[0];
	u_t = acc_td + k_v * e[5] + k_p * e[1] + v[1];
	u_l = acc_vd + k_v * e[6] + k_p * e[2] + v[2];
	u_r = acc_vd + k_v * e[7] + k_p * e[3] + v[3];*/

/* Control without the NN (i.e., CTC only) */
	
	u_p = acc_pd + k_v * e[4] + k_p * e[0];
	u_t = acc_td + k_v * e[5] + k_p * e[1];
	u_l = acc_vd + k_v * e[6] + k_p * e[2];
	u_r = acc_vd + k_v * e[7] + k_p * e[3];
	

//printf("u_p=%4f u_t=%4f u_l=%4f u_r=%4f \n",u_p, u_t, u_l, u_r);
	
/* Dynamic Simulation */
	
/* Calculating the motor torque commands only using the diagonal elements of the inertia matrix */

/* Pan motor torque command */
	
	T_p[0] = 2.0 * (k1 + k2 + 2.0*k5) * u_p;
//	T_p[0] = 2.0 * (0.0*k1 + k2 + 2.0*k5) * u_p; /* Introducing further dynamic uncertainties by making k1 = 0 for comparison */

/* Tilt motor torque command */

	T_t[0] = 2.0 * k4 * u_t;
//	T_t[0] = 2.0 *0.5 * k4 * u_t;	/* Try with the 50% of the diagonal element, m22, only */

/* Left and right camera motor torque commands */

	T_l[0] = 2.0 * (k6 * pow(cos(theta_t),2) + k8) * u_l;
	T_r[0] = 2.0 * (k6 * pow(cos(theta_t),2) + k8) * u_r;

/* One can use the off-diagonal elements as well for comparison */
//	T_l[0] = (k7*cos(theta_t)*sin(theta_l) - 2*k6*pow(cos(theta_t),2)) * u_p + 2.0 * (k6 * pow(cos(theta_t),2) + k8) * u_l;
//	T_r[0] = -(k7*cos(theta_t)*sin(theta_l) - 2*k6*pow(cos(theta_t),2)) * u_p + 2.0 * (k6 * pow(cos(theta_t),2) + k8) * u_r;

	/* elements of the inertia matrix */
	
	m11 = 2.0 * (k1 + k2 + 2.0*k5 + k3*sin(theta_t) - k7*cos(theta_t)*(sin(theta_l)+sin(theta_r)));
	m12 = k7 * sin(theta_t) * (cos(theta_l) - cos(theta_r));
	m13 = cos(theta_t) * (2.0 * k6 * cos(theta_t) + k7 * sin(theta_l));
	m14 = cos(theta_t) * (2.0 * k6 * cos(theta_t) - k7 * sin(theta_r));
	m21 = k7 * sin(theta_t) * (cos(theta_l) - cos(theta_r));
	m22 = 2.0 * (k4 + 2.0 * k6);
	m31 = k7 * cos(theta_t) * sin(theta_l) - 2.0 * k6 * pow(cos(theta_t),2);
	m33 = 2.0 * (k6 * pow(cos(theta_t),2) + k8);
	m41 = -k7 * cos(theta_t) * sin(theta_r) + 2.0 * k6 * pow(cos(theta_t),2);
	m44 = 2.0 * (k6 * pow(cos(theta_t),2) + k8);
	
	/* calculating the determinant of the inertia matrix required when inverting the matrix */
	
	D_m = -m41*m33*m22*m14 - m44*m31*m22*m13 + m44*m11*m22*m33 - m44*m12*m21*m33;
	
	/* Cofactors of the inertia matrix */
	
	M[0][0] = m22*m33*m44;
	M[0][1] = -m21*m33*m44;
	M[0][2] = -m22*m31*m44;
	M[0][3] = -m22*m33*m41;
	M[1][0] = -m44*m12*m33;
	M[1][1] = -m41*m33*m14 + m44*m11*m33 - m44*m13*m31;
	M[1][2] = m31*m12*m44;
	M[1][3] = m41*m12*m33;
	M[2][0] = -m44*m22*m13;
	M[2][1] = m13*m21*m44;
	M[2][2] = -m41*m22*m14 + m44*m11*m22 - m44*m12*m21;
	M[2][3] = m41*m22*m13;
	M[3][0] = -m14*m22*m33;
	M[3][1] = m14*m21*m33;
	M[3][2] = m14*m22*m31;
	M[3][3] = -m31*m22*m13+m33*m11*m22-m33*m12*m21;
	
	/* calculating the elements of the inertia matrix inverse */
	
	for (i=0; i<=3; i++)
	    for (j=0; j<=3; j++)
	         I[i][j] = M[j][i]/D_m;
	         
	/* centrifugal, corriolis, and gravity terms */
	
	h_p = k7 * cos(theta_t) * ((cos(theta_l)-cos(theta_r)) * pow(vel_t,2) + cos(theta_l) * pow(vel_l,2) - 
	      cos(theta_r) * pow(vel_r,2)) + 2.0 * (k3 * sin(2.0*theta_t) + k7 * sin(theta_t) * (sin(theta_l)+
	      sin(theta_r))) * vel_p*vel_t - 2.0 * k7 * cos(theta_t) * cos(theta_l) * vel_p*vel_l - 
	      2.0 * k7 * cos(theta_t) * cos(theta_r) * vel_p*vel_r - 2.0 * (k6 * sin(2.0*theta_t) + 
	      k7 * sin(theta_t) * sin(theta_l)) * vel_t*vel_l - 2.0 * (k6 * sin(2.0*theta_t) - 
	      k7 * sin(theta_t) * sin(theta_r)) * vel_t*vel_r;
	h_t = -(2.0 * k3 * cos(theta_t) - 4.0 * k6 * cos(theta_t) + k7 * sin(theta_r) + 
	      k7 * sin(theta_l)) * sin(theta_t) * pow(vel_p,2) + k6 * sin(2.0*theta_t) * ( 2.0 * pow(vel_l,2) +        		  pow(vel_r,2) - 2.0 * vel_p * vel_l + 2.0 * vel_p * vel_r) + k9*9.8*sin(theta_t) + k10*9.8*cos(theta_t) 
	h_l = 2.0 * k6 * sin(2.0*theta_t) * (vel_p * vel_t - vel_t * vel_l) + 
	      k7 * cos(theta_t) * cos(theta_l) * pow(vel_p,2);
	h_r = -2.0 * k6 * sin(2.0*theta_t) * (vel_p * vel_t + vel_t * vel_r) + 
	      k7 * cos(theta_t) * cos(theta_r) *pow(vel_p,2);
	      
	/* Calculating the acceleration vector: this will be numerically integrated in the main body of the program to obtain the joint positions and velocities */
	
	acc_p[0] = I[0][0] * (T_p[0] - h_p) + I[0][1] * (T_t[0] - h_t) + I[0][2] * (T_l[0] - h_l) + I[0][3] * (T_r[0] - h_r);
	acc_t[0] = I[1][0] * (T_p[0] - h_p) + I[1][1] * (T_t[0] - h_t) + I[1][2] * (T_l[0] - h_l) + I[1][3] * (T_r[0] - h_r);
	acc_l[0] = I[2][0] * (T_p[0] - h_p) + I[2][1] * (T_t[0] - h_t) + I[2][2] * (T_l[0] - h_l) + I[2][3] * (T_r[0] - h_r);
	acc_r[0] = I[3][0] * (T_p[0] - h_p) + I[3][1] * (T_t[0] - h_t) + I[3][2] * (T_l[0] - h_l) + I[3][3] * (T_r[0] - h_r);
	      	
}

void E( double theta_pd, double theta_td, double theta_vd, double vel_pd, double vel_td, double vel_vd, 
	double theta_p, double theta_t, double theta_l, double theta_r, double vel_p, double vel_t,  double vel_l, 
	double vel_r, double e[]){

    /* Position errors */
    e[0] = theta_pd - theta_p;
	e[1] = theta_td - theta_t;
	e[2] = theta_vd - theta_l;
	e[3] = theta_vd - theta_r;
	
	/* Velocity errors */
	e[4] = vel_pd - vel_p;
	e[5] = vel_td - vel_t;
	e[6] = vel_vd - vel_l;
	e[7] = vel_vd - vel_r;
	
}

void featPara( double X_l[], double X_r[], double Y_l[], double Y_r[], double Z_l[], double Z_r[], 
               double d[], double x[], double y[])
{
   double lamda=0.75;
   
   d[0] = (-X_l[0]/Z_l[0] + X_r[0]/Z_r[0]) * lamda/2;
   x[0] =-(X_l[0]/Z_l[0] + X_r[0]/Z_r[0]) * lamda/2;
   y[0] = (Y_l[0]/Z_l[0] + Y_r[0]/Z_r[0]) * lamda/2;

//printf("d[0]=%4f x[0]=%4f y[0]=%4f\n",d[0], x[0], y[0]);
}

void relPose(double theta_v, double theta_p, double theta_t, double rhos, double phis, double gammas , double X_l[], 
			 double X_r[], double Y_l[], double Y_r[], double Z_l[], double Z_r[]){
    
    int B = 30;
    
    X_l[0] = rhos * cos(gammas) * cos(theta_v) * sin(phis - theta_p) + rhos * cos(gammas) * cos(theta_t) 
        * sin(theta_v) * cos(phis - theta_p) + rhos * sin(gammas) * sin(theta_t) * sin(theta_v) - cos(theta_v)*B/2.0;
    X_r[0] = rhos * cos(gammas) * cos(theta_v) * sin(phis - theta_p) - rhos * cos(gammas) * cos(theta_t) 
        * sin(theta_v) * cos(phis - theta_p) - rhos * sin(gammas) * sin(theta_t) * sin(theta_v) + cos(theta_v)*B/2.0;
    Y_l[0] =-rhos * cos(gammas) * sin(theta_t) * cos(phis-theta_p) + rhos * sin(gammas) * cos(theta_t);
    Y_r[0] =-rhos * cos(gammas) * sin(theta_t) * cos(phis-theta_p) + rhos * sin(gammas) * cos(theta_t);
    Z_l[0] =-rhos * cos(gammas) * sin(theta_v) * sin(phis-theta_p) + rhos * cos(gammas) * cos(theta_t) 
        * cos(theta_v) * cos(phis-theta_p) + rhos * sin(gammas) * sin(theta_t) * cos(theta_v) + sin(theta_v)*B/2.0;
    Z_r[0] = rhos * cos(gammas) * sin(theta_v) * sin(phis-theta_p) + rhos * cos(gammas) * cos(theta_t) 
        * cos(theta_v) * cos(phis-theta_p) + rhos * sin(gammas) * sin(theta_t) * cos(theta_v) + sin(theta_v)*B/2.0;
    
   //printf("X_l[0]=%4f X_r[0]=%4f Y_l[0]=%4f Y_r[0]=%4f Z_l[0]=%4f Z_r[0]=%4f \n", X_l[0],X_r[0],Y_l[0],Y_r[0],
         // Z_l[0],Z_r[0]);
    
    }


void headMove(double theta_v, double theta_p, double theta_t, double d_rho, double d_phi, double d_gamma, 
              double dd, double dx, double dy, double dtheta_v[], double dtheta_p[], double dtheta_t[])
{
      
      int B = 30;
      
      dtheta_v[0] = -1.1*dd - 2*sin(theta_v)*sin(theta_v)*d_rho/B;
      dtheta_p[0] = 1.1*dx/(cos(theta_t)*cos(theta_v)*cos(theta_v)) + 0.6*d_phi;
      dtheta_t[0] = -1.1*dy/cos(theta_v) + 0.7*d_gamma;
      
   }
    

void imageCoord(double X_l[], double X_r[], double Y_l[], double Y_r[], double Z_l[], double Z_r[], double x_l[],                double y_l[], double x_r[], double y_r[])	
{
   double lamda=0.75;
   
   x_l[0] =-lamda * X_l[0]/Z_l[0];
   y_l[0] = lamda * Y_l[0]/Z_l[0];
   x_r[0] =-lamda * X_r[0]/Z_r[0];
   y_r[0] = lamda * Y_r[0]/Z_r[0];

}

void nocont( double rhos, double phis, double gammas , double dnc[], double xnc[], double ync[], 
             double x_lnc[], double y_lnc[], double x_rnc[], double y_rnc[]){
    
    int B = 30.0;
    double lamda=0.75;
    double theta_p=0.0;
    double theta_t=0.0;
    double theta_v=0.0;
    double X_l[1], X_r[1], Y_l[1], Y_r[1], Z_l[1], Z_r[1];
     
    X_l[0] = rhos * cos(gammas) * cos(theta_v) * sin(phis - theta_p) + rhos * cos(gammas) * cos(theta_t) 
        * sin(theta_v) * cos(phis - theta_p) + rhos * sin(gammas) * sin(theta_t) * sin(theta_v) - cos(theta_v)*B/2.0;
    X_r[0] = rhos * cos(gammas) * cos(theta_v) * sin(phis - theta_p) - rhos * cos(gammas) * cos(theta_t) 
        * sin(theta_v) * cos(phis - theta_p) - rhos * sin(gammas) * sin(theta_t) * sin(theta_v) + cos(theta_v)*B/2.0;
    Y_l[0] =-rhos * cos(gammas) * sin(theta_t) * cos(phis-theta_p) + rhos * sin(gammas) * cos(theta_t);
    Y_r[0] =-rhos * cos(gammas) * sin(theta_t) * cos(phis-theta_p) + rhos * sin(gammas) * cos(theta_t);
    Z_l[0] =-rhos * cos(gammas) * sin(theta_v) * sin(phis-theta_p) + rhos * cos(gammas) * cos(theta_t) 
        * cos(theta_v) * cos(phis-theta_p) + rhos * sin(gammas) * sin(theta_t) * cos(theta_v) + sin(theta_v)*B/2.0;
    Z_r[0] = rhos * cos(gammas) * sin(theta_v) * sin(phis-theta_p) + rhos * cos(gammas) * cos(theta_t) 
        * cos(theta_v) * cos(phis-theta_p) + rhos * sin(gammas) * sin(theta_t) * cos(theta_v) + sin(theta_v)*B/2.0;

    
   //printf("X_l[0]=%4f X_r[0]=%4f Y_l[0]=%4f Y_r[0]=%4f Z_l[0]=%4f Z_r[0]=%4f \n", //X_l[0],X_r[0],Y_l[0],Y_r[0],
     //      Z_l[0],Z_r[0]);
    
   
   dnc[0] = (-X_l[0]/Z_l[0] + X_r[0]/Z_r[0]) * lamda/2;
   xnc[0] =-(X_l[0]/Z_l[0] + X_r[0]/Z_r[0]) * lamda/2;
   ync[0] = (Y_l[0]/Z_l[0] + Y_r[0]/Z_r[0]) * lamda/2;
   
   x_lnc[0] =-lamda * X_l[0]/Z_l[0];
   y_lnc[0] = lamda * Y_l[0]/Z_l[0];
   x_rnc[0] =-lamda * X_r[0]/Z_r[0];
   y_rnc[0] = lamda * Y_r[0]/Z_r[0];

//printf("xnc[0]=%4f ync[0]=%4f\n",xnc[0], ync[0]);
    
}

int main( void )
{
   int i,j,k,r;		/* r is the number of neurons in the hidden layer */
   double v[4];		/* NN signal vector */
   float w[4][10], ps[10][12], zig[10][12]; /* RBF's NN's connecting wights, center states, and standard deviations, respectively */
   float xx;
   double e[8];                 /* vector of joint position and velocity errors */
   double d[1], x[1], y[1] ;	/* image feature parameters: disparity, x_ave, y_ave */                                          
   double dnc[1], xnc[1], ync[1];                    /* image feature parameters if head's not controlled */
   float dt;                                         /* sampling interval */
   float t;                                          /* current time */
   float endTime;
   double theta_p, theta_t, theta_v, theta_l, theta_r; /*  pan, tilt and camera angles */
   double vel_p, vel_t, vel_l, vel_r;                  /* first time derivatives of p, t, l, r)*/
   double acc_p[1], acc_t[1], acc_l[1], acc_r[1];      /* second time derivatives of p, t, l, r)*/ 
   double theta_vd, theta_pd, theta_td;                /* desired vergence, pan, tilt angles */
   double vel_pd, vel_td, vel_vd;                      /* first time derivatives of desired p, t, v(l,r)*/
   double acc_pd, acc_td, acc_vd;                      /* second time derivatives of desired p, t, v(l,r)*/ 
   double d_0, x_0, y_0;
   double X_l[1], X_r[1], Y_l[1], Y_r[1], Z_l[1], Z_r[1]; /*relative pose betwen targ. & cams.*/
   double x_l[1], y_l[1], x_r[1], y_r[1];                 /* image coordinates, L & R cameras */
   double x_lnc[1], y_lnc[1], x_rnc[1], y_rnc[1];		  /* image coordinates if the head is not controlled */	
   double dd, dx, dy;                                     /* change in image feature parameters */
   double dtheta_v[1], dtheta_p[1], dtheta_t[1];
   double rhos, phis, gammas;
   double d_rhos, d_phis, d_gammas;
   float rho_0, phi_0, gamma_0;
   float pd_0, td_0, vd_0;
   float vel_pd_0, vel_td_0, vel_vd_0;
   double d_rho, d_phi, d_gamma;
   float rho, phi,gamma; 
   float X, Y, Z;                      /* Target position, World frame */
   int totalStep;
   int X_0, Y_0, Z_0;                  /* Target initial position */
   float T_p[1], T_t[1], T_l[1], T_r[1];	/* Motor torques */
   
	FILE *fp;

	
	if ((fp=fopen("data.dat","w"))==NULL){
	
		printf("Can't open File\n");
		exit(1);
	}
		

   dt = 0.02;
   endTime = 12.0;
   totalStep = (int)(endTime/dt);
   
   /* initial conditions */
   /* target configuration parameters */

   X_0 = 0.0;
   Y_0 = 0.0;
   Z_0 = 200.0;
   rho_0 = sqrt(pow(X_0,2) + pow(Y_0,2) + pow(Z_0,2));
   phi_0 = atan2(X_0,Z_0);
   gamma_0 = atan2(Y_0*cos(atan2(X_0,Z_0)),Z_0);
     
   /* head configuration parameters */
  
   theta_p = phi_0;            
   theta_t = gamma_0;
   theta_v = atan2(15.0,rho_0);
   theta_l = atan2(15.0,rho_0);
   theta_r = atan2(15.0,rho_0);
   
   /* initial velocity */
   vel_p = 0.0;
   vel_t = 0.0;
   vel_l = 0.0;
   vel_r = 0.0;
   
   /* initial acceleration */
   acc_p[0] = 0.0;
   acc_t[0] = 0.0;
   acc_l[0] = 0.0;
   acc_r[0] = 0.0;
   
   /* desired position */
   vd_0 = atan2(15.0,rho_0);
   pd_0 = phi_0;
   td_0 = gamma_0;
   
   /* desired velocity */
   vel_pd_0 = 0.0;
   vel_td_0 = 0.0;
   vel_vd_0 = 0.0;
      
   /* image feature parameters */
   d_0 = 0.0;
   x_0 = 0.0;
   y_0 = 0.0;
   
	r = 10;   /* No of neurons in the RBFNN */ 
	
     /* Initializing weights(w's) */
	 /* Note here that all the weights are initialized inn the range [-0.5, 0.5] */

	for (i=0; i<=3; i++)
		for (j=0; j<=r-1; j++){
			xx = rand()/2147483647.0;
			w[i][j] = -0.50 + 1.0 * xx;
			//fprintf(fp,"w[%d][%d]=%f \n",i,j,w[i][j]);
    }
    
     /* Initializing weights(ps's) */
   
	for (i=0; i<=r-1; i++)
		for (j=0; j<=11; j++){
		xx = rand()/2147483647.0;
		ps[i][j] = -0.50 + 1.0 * xx;
		//fprintf(fp,"%f\n",ps[i][j]);
    }

     /* Initializing weights(zig's) */
   
	for (i=0; i<=r-1; i++)
	   for (j=0; j<=11; j++){
	   xx = rand()/2147483647.0;
		zig[i][j] = -0.50 + 1.0 * xx;
		//fprintf(fp,"%f\n",zig[i][j]);
	}
    	    	    
    	    	    
    /* ***************** CONTROL LOOP ***************** */
    
	   for (j = 0; j <= totalSteps; j++) {
   	   
	       t = dt * j;
			
			/* Simulated trajectory, "TrajVergence" */

	   	     
			X = X_0;
			Y = Y_0;
			Z = Z_0 + 20.0 * t; 
					  
		   
		   /* Simulated trajectory, "TrajPan" */

	   	    /* 
			if ( t <= 3.0 )
			{
				X = 200.0*sin(0.125*pi*t);
				Y = Y_0;
				Z = 200.0*cos(0.125*pi*t);
			}
				else if ( t > 3.0 &&  t <= 9.0 )
				{
					X = 200.0*sin(0.375*pi - 0.125*pi*(t-3.0));
					Y = Y_0;
					Z = 200.0*cos(0.375*pi - 0.125*pi*(t-3.0));
				}
					else 
					{
						X = -200.0*sin(0.375*pi);
						Y = Y_0;
						Z =  200.0*cos(0.375*pi);
					}
			*/

		   /* Simulated trajectory, "TrajTilt" */
	   	    
		    /* 
			if ( t <= 3.0 )
			{
				X = X_0;
				Y = 200.0*sin(0.125*pi*t);
				Z = 200.0*cos(0.125*pi*t);
			}
				else if ( t > 3.0 &&  t <= 9.0 )
				{
					X = X_0;
					Y = 200.0*sin(0.375*pi - 0.125*pi*(t-3.0));
					Z = 200.0*cos(0.375*pi - 0.125*pi*(t-3.0));
				}
					else 
					{
						X = X_0;
						Y = -200.0*sin(0.375*pi);
						Z = 200.0*cos(0.375*pi);
					}
			*/
			

		   X=a*sin(pi*t);
    	   Y=b*cos(pi*t);
           Z=200.0;
		      rhos   = sqrt(pow(X,2) + pow(Y,2) + pow(Z,2));
		      phis   = atan2(X,Z);
		      gammas = atan2(Y*cos(atan2(X,Z)),Z);
       
      relPose(theta_v, theta_p, theta_t, rhos, phis, gammas, X_l, X_r, Y_l, Y_r, Z_l, Z_r);
 
//printf("X_l=%4f Y_l=%4f X_r=%4f Y_r=%4f \n",X_l,Y_l,X_r,Y_r);
       featPara( X_l, X_r, Y_l, Y_r, Z_l, Z_r, d, x, y );
       
         dd = -d[0] + d_0;
         dx = -x[0] + x_0;
         dy = -y[0] + y_0;
         
//printf("x[0]=%4f y[0]=%4f \n",x[0],y[0]);
//printf("dx=%1.8f dy=%1.8f \n",dx,dy);
        
        rho   = 15.0/tan(theta_v);
        phi   = theta_p;
        gamma = theta_t;
        
        d_rho = rho - rho_0;
        d_phi = phi - phi_0;
        d_gamma = gamma - gamma_0;
        
        rho_0 = rho;
        phi_0 = phi;
        gamma_0 = gamma;
        
        headMove(theta_v, theta_p, theta_t,  d_rho, d_phi, d_gamma, dd, dx, dy, dtheta_v, dtheta_p, dtheta_t);
         
         theta_pd = theta_p + dtheta_p[0];
         theta_td = theta_t + dtheta_t[0];
         theta_vd = theta_v + dtheta_v[0];
         
//fprintf(fp, "%4f %4f %4f %4f \n",t,theta_vd,theta_pd,theta_td);
//printf("dtheta_p[0]=%1.8f dtheta_t[0]=%1.8f \n",dtheta_p[0],dtheta_t[0]);

/* Calculation of time derivatives of desired joint angle positions */

         vel_pd = (theta_pd - pd_0)/dt;                /* First time derivative */
         vel_td = (theta_td - td_0)/dt;
         vel_vd = (theta_vd - vd_0)/dt;
       
         pd_0 = theta_pd;
         td_0 = theta_td;
         vd_0 = theta_vd;
         
         acc_pd = (vel_pd - vel_pd_0)/dt;              /* Second time derivative */
         acc_td = (vel_td - vel_td_0)/dt;
         acc_vd = (vel_vd - vel_vd_0)/dt;
         
         vel_pd_0 = vel_pd;
         vel_td_0 = vel_td;
         vel_vd_0 = vel_vd;
         
		E( theta_pd, theta_td, theta_vd, vel_pd, vel_td, vel_vd, theta_p, theta_t, theta_l, theta_r, vel_p, 
		  vel_t, vel_l, vel_r, e);
		  
		RBFNN( w, ps, zig, e, theta_p, theta_t, theta_l, theta_r, vel_p, vel_t, vel_l, vel_r, acc_p, acc_t, 
			  acc_l, acc_r, dt, v );
			         
		ctc( v, e, acc_pd, acc_td, acc_vd, theta_p, theta_t, theta_l, theta_r, vel_p, vel_t, vel_l, vel_r, acc_p, 
			  acc_t, acc_l, acc_r, T_p, T_t, T_l, T_r);
              
//fprintf(fp, "%4f %4f %4f %4f %4f \n",t, acc_p[0],acc_t[0],acc_l[0],acc_r[0]);
//fprintf(fp, "%4f %4f %4f %4f %4f \n",t, T_p[0], T_t[0], T_l[0], T_r[0]);
         
		/* Euler method to get angles and velocities */
         
         theta_p = theta_p + vel_p * dt + acc_p[0] * pow(dt,2)/2.0;
         theta_t = theta_t + vel_t * dt + acc_t[0] * pow(dt,2)/2.0;
         theta_l = theta_l + vel_l * dt + acc_l[0] * pow(dt,2)/2.0;
         theta_r = theta_r + vel_r * dt + acc_r[0] * pow(dt,2)/2.0;
         
         theta_v = (theta_l + theta_r)/2.0;
         
         vel_p = vel_p + acc_p[0] * dt;
         vel_t = vel_t + acc_t[0] * dt;
         vel_l = vel_l + acc_l[0] * dt;
         vel_r = vel_r + acc_r[0] * dt;
         
//fprintf(fp, "%4f %4f %4f %4f %4f %4f \n",t,theta_v,theta_p,theta_t, theta_l, theta_r);
//fprintf(fp, "%4f %4f %4f %4f %4f \n",t,vel_p,vel_t, vel_l, vel_r);

		E( theta_pd, theta_td, theta_vd, vel_pd, vel_td, vel_vd, theta_p, theta_t, theta_l, theta_r, vel_p,  vel_t, vel_l, vel_r, e);
	
        relPose( theta_v, theta_p, theta_t, rhos, phis, gammas, X_l, X_r, Y_l, Y_r, Z_l, Z_r );

//printf("X_l[0]=%4f Y_l[0]=%4f X_r[0]=%4f Y_r[0]=%4f \n",X_l[0],Y_l[0],X_r[0],Y_r[0]);
         
        imageCoord(  X_l, X_r, Y_l, Y_r, Z_l, Z_r, x_l, y_l, x_r, y_r );
         
//printf("t=%4f x_l[0]=%4f y_l[0]=%4f x_r[0]=%4f y_r[0]=%4f \n",t,x_l[0],y_l[0],x_r[0],y_r[0]);
//fprintf(fp, "%4f %4f %4f %4f %4f \n",t, x_l[0],   y_l[0],   x_r[0],   y_r[0]);

        featPara( X_l, X_r, Y_l, Y_r, Z_l, Z_r, d, x, y );

//printf("t=%4f d[0]=%4f x[0]=%4f y[0]=%4f \n",t,d[0],x[0],y[0]);
//fprintf(fp, "%4f %4f %4f %4f \n",t, d[0], x[0], y[0]);

        nocont(rhos, phis, gammas, dnc, xnc, ync, x_lnc, y_lnc, x_rnc, y_rnc);
         
//printf("t=%4f dnc[0]=%4f d[0]=%4f xnc[0]=%4f x[0]=%4f ync[0]=%4f y[0]=%4f \n",t,dnc[0],d[0],xnc[0],x[0],ync[0],y[0]);
//fprintf(fp, "t=%4f dnc=%4f d=%4f xnc=%4f x=%4f ync=%4f y=%4f \n",t,dnc[0],d[0],xnc[0],x[0],ync[0],y[0]); 
//fprintf(fp, "%4f %4f %4f %4f %4f %4f %4f \n",t,dnc[0],d[0],xnc[0],x[0],ync[0],y[0]); 
//fprintf(fp, "%4f %4f %4f %4f \n",t,d[0],x[0],y[0]);
//fprintf(fp, "%4f %4f %4f %4f %4f %4f %4f %4f %4f \n",t, x_l[0],   y_l[0],   x_r[0],   y_r[0],  
 //        x_lnc[0],   y_lnc[0],   x_rnc[0],   y_rnc[0]);   
         
       
}
       fclose(fp);
       return 0;
}
