#include<stdio.h>
#include<math.h>
#include<stdlib.h>

//#include"relpose.c"
//#include"jacobians.c"
//#include"headMove.c"

#define pi 3.141592653589793238
#define g 9.80665

void featPara( double X_l[], double X_r[], double Y_l[], double Y_r[], double Z_l[], double Z_r[], double d[],
			   double x[], double y[])
{
   double lamda=0.75;

   d[0] = (-X_l[0]/Z_l[0] + X_r[0]/Z_r[0]) * lamda/2;
   x[0] =-(X_l[0]/Z_l[0] + X_r[0]/Z_r[0]) * lamda/2;
   y[0] = (Y_l[0]/Z_l[0] + Y_r[0]/Z_r[0]) * lamda/2;

//printf("d[0]=%4f x[0]=%4f y[0]=%4f\n",d[0], x[0], y[0]);
}

void relPose(double theta_v, double theta_p, double theta_t, double rhos, double phis, double gammas , double X_l[], double X_r[], double Y_l[], double Y_r[], double Z_l[], double Z_r[]){

    int B = 30;

    X_l[0] = rhos * cos(gammas) * cos(theta_v) * sin(phis - theta_p) + rhos * cos(gammas) * cos(theta_t)
        * sin(theta_v) * cos(phis - theta_p) + rhos * sin(gammas) * sin(theta_t) * sin(theta_v) - cos(theta_v)*B/2.0;
    X_r[0] = rhos * cos(gammas) * cos(theta_v) * sin(phis - theta_p) - rhos * cos(gammas) * cos(theta_t)
        * sin(theta_v) * cos(phis - theta_p) - rhos * sin(gammas) * sin(theta_t) * sin(theta_v) + cos(theta_v)*B/2.0;
    Y_l[0] =-rhos * cos(gammas) * sin(theta_t) * cos(phis-theta_p) + rhos * sin(gammas) * cos(theta_t);
    Y_r[0] =-rhos * cos(gammas) * sin(theta_t) * cos(phis-theta_p) + rhos * sin(gammas) * cos(theta_t);
    Z_l[0] =-rhos * cos(gammas) * sin(theta_v) * sin(phis-theta_p) + rhos * cos(gammas) * cos(theta_t)
        * cos(theta_v) * cos(phis-theta_p) + rhos * sin(gammas) * sin(theta_t) * cos(theta_v) + sin(theta_v)*B/2.0;
    Z_r[0] = rhos * cos(gammas) * sin(theta_v) * sin(phis-theta_p) + rhos * cos(gammas) * cos(theta_t)
        * cos(theta_v) * cos(phis-theta_p) + rhos * sin(gammas) * sin(theta_t) * cos(theta_v) + sin(theta_v)*B/2.0;

   //printf("X_l[0]=%4f X_r[0]=%4f Y_l[0]=%4f Y_r[0]=%4f Z_l[0]=%4f Z_r[0]=%4f \n", X_l[0],X_r[0],Y_l[0],Y_r[0],
         // Z_l[0],Z_r[0]);
    
    }


void headMove(double theta_v, double theta_p, double theta_t, double d_rho, double d_phi, double d_gamma, 
              double dd, double dx, double dy, double dtheta_v[], double dtheta_p[], double dtheta_t[])
{
      int B = 30;
      
/*      dtheta_v[0] = -dd - 2*sin(theta_v)*sin(theta_v)*d_rho/B;
      dtheta_p[0] = dx/(cos(theta_t)*cos(theta_v)*cos(theta_v))+ d_phi ;
      dtheta_t[0] = -dy/cos(theta_v) + d_gamma; */
/*      dtheta_v[0] = -1.3*dd - 0.4*2*sin(theta_v)*sin(theta_v)*d_rho/B;
      dtheta_p[0] = 1.1*dx/(cos(theta_t)*cos(theta_v)*cos(theta_v))+ 0.6*d_phi ;
      dtheta_t[0] = -1.1*dy/cos(theta_v) + 0.7*d_gamma;*/ 
      dtheta_v[0] = -dd - 0.9*2*sin(theta_v)*sin(theta_v)*d_rho/B;
      dtheta_p[0] = dx/(cos(theta_t)*cos(theta_v)*cos(theta_v))+ 0.8*d_phi ;
      dtheta_t[0] = -dy/cos(theta_v) + 0.7*d_gamma;  

}

void imageCoord(double X_l[], double X_r[], double Y_l[], double Y_r[], double Z_l[], double Z_r[], double x_l[],
                double y_l[], double x_r[], double y_r[])
{
   double lamda=0.75;
   
   x_l[0] =-lamda * X_l[0]/Z_l[0];
   y_l[0] = lamda * Y_l[0]/Z_l[0];
   x_r[0] =-lamda * X_r[0]/Z_r[0];
   y_r[0] = lamda * Y_r[0]/Z_r[0];

}

void nocont( double rhos, double phis, double gammas , double dnc[], double xnc[], double ync[], double x_lnc[],
             double y_lnc[], double x_rnc[], double y_rnc[]){
    
    int B = 30.0;
    double lamda=0.75;
    double theta_p=0.0;
    double theta_t=0.0;
    double theta_v=0.0;
    double X_l[1], X_r[1], Y_l[1], Y_r[1], Z_l[1], Z_r[1];
     
    X_l[0] = rhos * cos(gammas) * cos(theta_v) * sin(phis - theta_p) + rhos * cos(gammas) * cos(theta_t) 
        * sin(theta_v) * cos(phis - theta_p) + rhos * sin(gammas) * sin(theta_t) * sin(theta_v) - cos(theta_v)*B/2.0;
    X_r[0] = rhos * cos(gammas) * cos(theta_v) * sin(phis - theta_p) - rhos * cos(gammas) * cos(theta_t) 
        * sin(theta_v) * cos(phis - theta_p) - rhos * sin(gammas) * sin(theta_t) * sin(theta_v) + cos(theta_v)*B/2.0;
    Y_l[0] =-rhos * cos(gammas) * sin(theta_t) * cos(phis-theta_p) + rhos * sin(gammas) * cos(theta_t);
    Y_r[0] =-rhos * cos(gammas) * sin(theta_t) * cos(phis-theta_p) + rhos * sin(gammas) * cos(theta_t);
    Z_l[0] =-rhos * cos(gammas) * sin(theta_v) * sin(phis-theta_p) + rhos * cos(gammas) * cos(theta_t) 
        * cos(theta_v) * cos(phis-theta_p) + rhos * sin(gammas) * sin(theta_t) * cos(theta_v) + sin(theta_v)*B/2.0;
    Z_r[0] = rhos * cos(gammas) * sin(theta_v) * sin(phis-theta_p) + rhos * cos(gammas) * cos(theta_t) 
        * cos(theta_v) * cos(phis-theta_p) + rhos * sin(gammas) * sin(theta_t) * cos(theta_v) + sin(theta_v)*B/2.0;

    
   //printf("X_l[0]=%4f X_r[0]=%4f Y_l[0]=%4f Y_r[0]=%4f Z_l[0]=%4f Z_r[0]=%4f \n", //X_l[0],X_r[0],Y_l[0],Y_r[0],
     //      Z_l[0],Z_r[0]);
    
   
   dnc[0] = (-X_l[0]/Z_l[0] + X_r[0]/Z_r[0]) * lamda/2;
   xnc[0] =-(X_l[0]/Z_l[0] + X_r[0]/Z_r[0]) * lamda/2;
   ync[0] = (Y_l[0]/Z_l[0] + Y_r[0]/Z_r[0]) * lamda/2;
   
   x_lnc[0] =-lamda * X_l[0]/Z_l[0];
   y_lnc[0] = lamda * Y_l[0]/Z_l[0];
   x_rnc[0] =-lamda * X_r[0]/Z_r[0];
   y_rnc[0] = lamda * Y_r[0]/Z_r[0];

//printf("xnc[0]=%4f ync[0]=%4f\n",xnc[0], ync[0]);   
}

int main( void )
{
   int jj, i,j;
   int r1 = 15; 									/* number of neurons -- pan net */
   int r2 = 20;										/*          -do-     -- tilt net*/
   int r3 = 10;										/*          -do-     -- left-cam net */ 
   int r4 = 10;										/*          -do-     -- right-cam net */ 
   int q1 = 8;                                      /* qi; i=1,2,3,4 is the number of inputs to the neural subnet */
   int q2 = 7;
   int q3 = 6;
   int q4 = 6;
   float w1[r1], w2[r2], w3[r3], w4[r4], ps1[r1][q1], ps2[r2][q2], ps3[r3][q3], ps4[r4][q4], zig1[r1][q1], zig2[r2][q2], zig3[r3][q3], zig4[r4][q4];
   float xx;
   double d[1], x[1], y[1];			     /* image feature parameter disparity, x_ave, y_ave */
   double dnc[1], xnc[1], ync[1];                    /* image feature parameters if head's not controlled */
   double x_lnc[1], y_lnc[1], x_rnc[1], y_rnc[1];
   float dt, t, endTime;
   double theta_p, theta_t, theta_v, theta_l, theta_r; /* pan, tilt and camera angles */
   double vel_p, vel_t, vel_l, vel_r;                  /* first time derivatives of p, t, l, r) */
   double acc_p[1], acc_t[1], acc_l[1], acc_r[1];      /* second time derivatives of p, t, l, r */
   double theta_vd, theta_pd, theta_td;                /* desired vergence, pan, tilt angles */
   double vel_pd, vel_td, vel_vd;                      /* first time derivatives of desired p, t, v(l,r) */
   double acc_pd, acc_td, acc_vd;                      /* second time derivatives of desired p, t, v(l,r) */
   double d_0, x_0, y_0;
   double X_l[1], X_r[1], Y_l[1], Y_r[1], Z_l[1], Z_r[1]; /* relative pose betwen targ. & cams. */
   double x_l[1], y_l[1], x_r[1], y_r[1];                 /* image coordinates, L & R cameras */
   double dd, dx, dy;                                     /* change in image feature parameters */
   double dtheta_v[1], dtheta_p[1], dtheta_t[1];
   double rhos, phis, gammas;
   double d_rhos, d_phis, d_gammas;
   float rho_0, phi_0, gamma_0;
   float pd_0, td_0, vd_0;
   float vel_pd_0, vel_td_0, vel_vd_0;
   double d_rho, d_phi, d_gamma;
   float rho, phi, gamma; 
   float X, Y, Z, Xh, Yh, Zh;                      /* Target position, World frame */
   int totalSteps;
   int X_0, Y_0, Z_0;                              /* Target initial position */

   double z[4];
   double theta_hat[4], vel_hat[4], theta_0[4];

   
	FILE *fp;

	
	if ((fp=fopen("data.dat","w"))==NULL){
	
		printf("Can't open File\n");
		exit(1);
	}
		
   dt = 0.002;
   endTime = 78.0;	 /* 4s A->B along diagonal, 2.82s B->C parallel to X axis, 2.82s C->A parallel to Y axis */
   totalSteps = (int)(endTime/dt);
   
   /* initial conditions */
   /* target configuration parameters */
   X_0 = -300.0;
   Y_0 = -300.0;
   Z_0 = 200.0;

/*   X_0 = 0.0;    // for
   Y_0 = 90.0;   // elliptical
   Z_0 = 200.0;  // motion    */

   rho_0 = sqrt(pow(X_0,2) + pow(Y_0,2) + pow(Z_0,2));
   phi_0 = atan2(X_0,Z_0);
   gamma_0 = atan2(Y_0*cos(atan2(X_0,Z_0)),Z_0);

   /* head configuration parameters */
  
   theta_p = phi_0;            
   theta_t = gamma_0;
   theta_v = atan2(15.0,rho_0);
   theta_l = atan2(15.0,rho_0);
   theta_r = atan2(15.0,rho_0);

   theta_hat[0] = theta_p ;     theta_hat[1] = theta_t;       theta_hat[2] = theta_l;       theta_hat[3] = theta_r;
   theta_0[0]   = theta_p ;     theta_0[1]   = theta_t;       theta_0[2]   = theta_l;       theta_0[3]   = theta_r;

   /* initial velocity */
   // See in the program
   // This's selected to be equal to the desired velocities
   
   /* initial acceleration */
   acc_p[0] = acc_t[0] = acc_l[0] = acc_r[0] = 0.0;
   
   /* desired position */
   vd_0 = atan2(15.0,rho_0);
   pd_0 = phi_0;
   td_0 = gamma_0;
   
   /* velocity desired */
   vel_pd_0 = 0.0;
   vel_td_0 = 0.0;
   vel_vd_0 = 0.0;
      
   /* image feature parameters */
   d_0 = 0.0;
   x_0 = 0.0;
   y_0 = 0.0;
   	
   /* Initializing weights(w's), respectively, for pan, tilt, left-camera, and right-camera subnets */
    
       for (i=0; i<=r1-1; i++){
                xx = rand()/2147483647.0;
                w1[i] = -0.05 + 0.1 * xx;
                //printf("w[%d][%d]=%f \n",i,j,w[i][j]);
       }

       for (i=0; i<=r2-1; i++){
                xx = rand()/2147483647.0;
                w2[i] = -0.1 + 0.2 * xx;
       }

       for (i=0; i<=r3-1; i++){
                xx = rand()/2147483647.0;
                w3[i] = 0.0;
       }

       for (i=0; i<=r4-1; i++){
                xx = rand()/2147483647.0;
                w4[i] = 0.0;//-0.5 + 1.0 * xx;
       }
        
     /* Initializing the centers(ps's) */
   
		for (i=0; i<=r1-1; i++)
			for (j=0; j<=q1-1; j++){
				xx = rand()/2147483647.0;
				ps1[i][j] = -0.5 + 1.0 * xx;
				//fprintf(fp,"%f\n",ps[i][j]);
			}

        for (i=0; i<=r2-1; i++)
			for (j=0; j<=q2-1; j++){
				xx = rand()/2147483647.0;
				ps2[i][j] = -0.5 + 1.0 * xx;
                ps2[i][0] = -5.0 + 10.0 * xx;
                ps2[i][1] = 10.0 - 10.0 * xx; //and r2=25 give good results
                //ps2[i][1] = 8.0 - 8.0 * xx;
				//fprintf(fp,"%f\n",ps[i][j]);
			}

        for (i=0; i<=r3-1; i++)
			for (j=0; j<=q3-1; j++){
				xx = rand()/2147483647.0;
				ps3[i][j] = -0.5 + 1.0 * xx;
				//fprintf(fp,"%f\n",ps[i][j]);
			}

        for (i=0; i<=r4-1; i++)
			for (j=0; j<=q4-1; j++){
				xx = rand()/2147483647.0;
				ps4[i][j] = -0.5 + 1.0 * xx;
				//fprintf(fp,"%f\n",ps[i][j]);
			}

     /* Initializing weights(zig's) */
     
	for (i=0; i<=r1-1; i++)
	   for (j=0; j<=q1-1; j++){
			zig1[i][j] = 8.0;//20.0;
			//fprintf(fp,"%f\n",zig[i][j]);
		}

	for (i=0; i<=r2-1; i++)
	   for (j=0; j<=q2-1; j++){
			zig2[i][j] = 8.0;
                //fprintf(fp,"%f\n",zig[i][j]);
		}

	for (i=0; i<=r3-1; i++)
	   for (j=0; j<=q3-1; j++){
			zig3[i][j] = 8.0;//20.0;
			//fprintf(fp,"%f\n",zig[i][j]);
		}

	for (i=0; i<=r4-1; i++)
	   for (j=0; j<=q4-1; j++){
			zig4[i][j] = 8.0;//20.0;
			//fprintf(fp,"%f\n",zig[i][j]);
		}

    /* ************************* CONTROL LOOP *************************** */
    
       for (jj = 0; jj <= totalSteps; jj++) {

	            t = dt * jj;
	       
       if ( t <= 4.0 ){
       X=X_0 + 150.0*t;     //target moves from (-X_0,-Y_0,200) to (X_0,Y_0,200) in 4s
       Y=Y_0 + 150.0*t;
       Z=Z_0;             
       }
       else if ( t > 4.0 &&  t <= 6.82 )
       {
       X=300.0 - (t-4.0)*212.132;
       Y=300.0;
       Z=Z_0;
       }
       else if ( t > 6.82 && t <= 9.64 )
       {
       X=-300.0;
       Y=300.0 - (t-6.82)*212.132;
       Z=Z_0;
       }
       else if ( t > 9.64 && t <= 12.46 )
       {
       X=-300.0 + (t-9.64)*212.132;
       Y=-300.0;
       Z=Z_0;
       }
       else if ( t > 12.46 && t <= 15.3 )
       {
       X=300.0;
       Y=-300.0 + (t-12.46)*212.132;
       Z=Z_0;
       }
       else if ( t > 15.3 && t <= 20.25 )
       {
       X=300.0 - (t-15.3)*600.0/4.95;
       Y=300.0 - (t-15.3)*600.0/4.95;
       Z=Z_0 + (t-15.3)*600.0/4.95;
       }
       else if ( t > 20.25 && t <= 24.25 )
       {
       X=-300.0 + (t-20.25)*150.0;
       Y=-300.0 + (t-20.25)*150.0;
       Z=800.0;
       }
       else if ( t > 24.25 && t <= 29.2 )
       {
       X=300.0 - (t-24.25)*600.0/4.95;
       Y=300.0 - (t-24.25)*600.0/4.95;
       Z=800.0 - (t-24.25)*600.0/4.95;
       }
       else if ( t > 29.2 && t <= 33.2 )
       {
       X=-300.0;
       Y=-300.0 + (t-29.2)*150.0;
       Z=200.0 + (t-29.2)*150.0;
       }
       else if ( t > 33.2 && t <= 36.02 )
       {
       X=-300.0 + (t-33.2)*212.132;
       Y=300.0;
       Z=800.0;
       }
       else if ( t > 36.02 && t <= 40.02 )
       {
       X=300.0;
       Y=300.0 - (t-36.02)*150.0;
       Z=800.0 - (t-36.02)*150.0;
       }
       else if ( t > 40.02 && t <= 44.02 )
       {
       X=300.0 - (t-40.02)*150.0;
       Y=-300.0;
       Z=200.0 + (t-40.02)*150.0;
       }
       else if ( t > 44.02 && t <= 46.84 )
       {
       X=-300.0;
       Y=-300.0;
       Z=800.0 - (t-44.02)*212.132;
       }
       else if ( t > 46.84 && t <= 51.79 )
       {
       X=-300.0 + (t-46.84)*600.0/4.95;
       Y=-300.0 + (t-46.84)*600.0/4.95;
       Z=200.0  + (t-46.84)*600.0/4.95;
       }
       else if ( t > 51.79 && t <= 54.61 )
       {
       X=300.0;
       Y=300.0 - (t-51.79)*212.132;
       Z=800.0;
       }
       else if ( t > 54.61 && t <= 57.42 )
       {
       X=300.0 - (t-54.61)*212.132;
       Y=-300.0;
       Z=800.0;
       }
       else if ( t > 57.42 && t <= 61.42 )
       {
       X=-300.0;
       Y=-300.0 + (t-57.42)*150.0;
       Z=800.0 - (t-57.42)*150.0;
       }
       else if ( t > 61.42 && t <= 64.3 )
       {
       X=-300.0;
       Y=300.0;
       Z=200.0 + (t-61.42)*208.333;
       }
       else if ( t > 64.3 && t <= 68.3 )
       {
       X=-300.0 + (t-64.3)*150.0;
       Y=300.0 - (t-64.3)*150.0;
       Z=800.0;
       }
       else if ( t > 68.3 && t <= 71.3 )
       {
       X=300.0;
       Y=-300.0;
       Z=800.0 - (t-68.3)*200.0;
       }
       else if ( t > 71.3 && t <= 74.3 )
       {
       X=300.0 - (t-71.3)*200.0;
       Y=-300.0 + (t-71.3)*200.0;
       Z=200.0 + (t-71.3)*200.0;
       }
       else if ( t > 74.3 && t <= 77.3 )
       {
       X=-300.0;
       Y=300.0 - (t-74.3)*200.0;
       Z=800.0;
       }

/*           X = 120.0* sin(pi*t);   // Elliptical
    	   Y = 90.0 * cos(pi*t);   // target
           Z =200.0;               // motion   */


		      rhos   = sqrt(pow(X,2) + pow(Y,2) + pow(Z,2));
		      phis   = atan2(X,Z);
		      gammas = atan2(Y*cos(atan2(X,Z)),Z);
       
		relPose(theta_v, theta_p, theta_t, rhos, phis, gammas, X_l, X_r, Y_l, Y_r, Z_l, Z_r);

//printf("X_l=%4f Y_l=%4f X_r=%4f Y_r=%4f \n",X_l,Y_l,X_r,Y_r);
 
		imageCoord(  X_l, X_r, Y_l, Y_r, Z_l, Z_r, x_l, y_l, x_r, y_r );

// +++++++++++++++++++++
//         fprintf(fp,"%6f %6f %6f %6f %6f \n", t, x_l[0], y_l[0], x_r[0], y_r[0]);
// +++++++++++++++++++++
		
		featPara( X_l, X_r, Y_l, Y_r, Z_l, Z_r, d, x, y );
       
         dd = -d[0] + d_0;
         dx = -x[0] + x_0;
         dy = -y[0] + y_0;
         
//fprintf(fp,"%4f %4f %4f %4f \n",t,x[0],y[0],d[0]);
//printf("dx=%1.8f dy=%1.8f \n",dx,dy);
        
        rho   = 15.0/tan(theta_v);
        phi   = theta_p;
        gamma = theta_t;
        
        d_rho = rho - rho_0;
        d_phi = phi - phi_0;
        d_gamma = gamma - gamma_0;
        
        rho_0 = rho;
        phi_0 = phi;
        gamma_0 = gamma;
        
        /* ****** CALCULATING FIXATION POINT IN CARTESIAN COORDINATES ****** */
        Xh = rho * cos(theta_t) * sin(theta_p);
        Yh = rho * sin(theta_t);
        Zh = rho * cos(theta_t) * cos(theta_p);
/*
if (jj % 20 == 0)
{
fprintf(fp, "%4f %4f %4f %4f %4f %4f %4f \n",t,X,Y,Z,Xh,Yh,Zh);
}
*/
							/*  **********  */

         headMove(theta_v, theta_p, theta_t, d_rho, d_phi, d_gamma, dd, dx, dy, dtheta_v, dtheta_p, dtheta_t);
         
         theta_pd = theta_p + dtheta_p[0];
         theta_td = theta_t + dtheta_t[0];
         theta_vd = theta_v + dtheta_v[0];
         
//fprintf(fp, "%4f %4f %4f %4f \n",t,theta_vd,theta_pd,theta_td);
//printf("dtheta_p[0]=%1.8f dtheta_t[0]=%1.8f \n",dtheta_p[0],dtheta_t[0]);

/*Calculation of time derivatives of desired positions*/

         vel_pd = (theta_pd - pd_0)/dt;                /* First time derivative */
         vel_td = (theta_td - td_0)/dt;
         vel_vd = (theta_vd - vd_0)/dt;

         if (t == 0) // Initial Conditions: Velocities
         {
         vel_p = vel_hat[0] = vel_pd; vel_t = vel_hat[1] = vel_td; vel_l = vel_r = vel_hat[2] = vel_hat[3] = vel_vd;
         z[0] = vel_pd; z[1] = vel_td; z[2] = z[3] = vel_vd;
         }
       
         pd_0 = theta_pd;
         td_0 = theta_td;
         vd_0 = theta_vd;
         
         acc_pd = (vel_pd - vel_pd_0)/dt;              /* Second time derivative */
         acc_td = (vel_td - vel_td_0)/dt;
         acc_vd = (vel_vd - vel_vd_0)/dt;
         
         vel_pd_0 = vel_pd;
         vel_td_0 = vel_td;
         vel_vd_0 = vel_vd;


 // ****************************XXXXXXXXXXXXXXXXXXXXXX**************************
 
        double nu[4];
        float Ld1, Ld2, Ld3, Ld4, Lp1, Lp2, Lp3, Lp4, Kd1, Kd2, Kd3, Kd4, Kp1, Kp2, Kp3, Kp4;

        Ld1 = 30.0;                Ld2 = 30.0;           Ld3 = 20.0;          Ld4 = 20.0;
        Lp1 = 3.0;                 Lp2 = 3.0;            Lp3 = 2.0;           Lp4 = 2.0;

        Kd1 = 7.0;          Kd2 = 7.0;          Kd3 = 7.0;         Kd4 = 7.0;
        Kp1 = 50.0;         Kp2 = 50.0;         Kp3 = 50.0;        Kp4 = 50.0;

        nu[0] = acc_pd - Kd1 * (vel_hat[0] - vel_pd) - Kp1 * (theta_p - theta_pd);
        nu[1] = acc_td - Kd2 * (vel_hat[1] - vel_td) - Kp2 * (theta_t - theta_td);
        nu[2] = acc_vd - Kd3 * (vel_hat[2] - vel_vd) - Kp3 * (theta_l - theta_vd);
        nu[3] = acc_vd - Kd4 * (vel_hat[3] - vel_vd) - Kp4 * (theta_r - theta_vd);

        z[0] = z[0] + dt * (nu[0] + Lp1 * (theta_p - theta_hat[0]));
        z[1] = z[1] + dt * (nu[1] + Lp2 * (theta_t - theta_hat[1]));
        z[2] = z[2] + dt * (nu[2] + Lp3 * (theta_l - theta_hat[2]));
        z[3] = z[3] + dt * (nu[3] + Lp4 * (theta_r - theta_hat[3]));

        vel_hat[0] = z[0] + Ld1 * (theta_p - theta_hat[0]);
        vel_hat[1] = z[1] + Ld2 * (theta_t - theta_hat[1]);
        vel_hat[2] = z[2] + Ld3 * (theta_l - theta_hat[2]);
        vel_hat[3] = z[3] + Ld4 * (theta_r - theta_hat[3]);

        for (i=0; i<=3; i++)
                theta_hat[i] = theta_hat[i] + dt * vel_hat[i];

// +++++++++++ PRINTING THE VELOCITY ERROR +++++++++++
//       fprintf(fp,"%2f %4f %4f %4f %4f \n", t, vel_hat[0], vel_hat[1], vel_hat[2], vel_hat[3]);
//fprintf(fp,"%2f %4f %4f %4f %4f \n", t, vel_p, vel_t, vel_l, vel_r);
//if (jj % 50 == 0){
//fprintf(fp,"%2f %4f %4f %4f %4f \n", t, vel_p-vel_hat[0], vel_t-vel_hat[1], vel_l-vel_hat[2], vel_r-vel_hat[3]);
//}
// +++++++++++++++++++++

                /* ************ NN & CONTROL LAW *********** */

        float m11, m12, m13, m14, m21, m22, m31, m33, m41, m44;
        double f1[r1], f2[r2], f3[r3], f4[r4], s[4], s_hat[4], slide[4], sign[4], v[4], m[4][4], M[4][4], w01[r1],
               w02[r2], w03[r3], w04[r4], D_m, I[4][4], T[4];

    double k1 = 0.0114651;	double k2  = 0.0131155;  double k3 = 0.0013466;  double k4 = 0.0026331;
	double k5 = 0.0002025; 	double k6  = 0.0000144;  double k7 = -0.000108;  double k8 = 0.000038477;
	double k9 = 0.0312730;  double k10 = -0.00144;

    m11 = m[0][0] = 2.0 * (k1 + k2 + 2.0*k5 + k3*sin(theta_t) - k7*cos(theta_t)*(sin(theta_l)+sin(theta_r)));
	m12 = m[0][1] = k7 * sin(theta_t) * (cos(theta_l) - cos(theta_r));
	m13 = m[0][2] = cos(theta_t) * (2.0 * k6 * cos(theta_t) + k7 * sin(theta_l));
	m14 = m[0][3] = cos(theta_t) * (2.0 * k6 * cos(theta_t) - k7 * sin(theta_r));
	m21 = m[1][0] = k7 * sin(theta_t) * (cos(theta_l) - cos(theta_r));
	m22 = m[1][1] = 2.0 * (k4 + 2.0 * k6);
	m31 = m[2][0] = k7 * cos(theta_t) * sin(theta_l) - 2.0 * k6 * pow(cos(theta_t),2);
	m33 = m[2][2] = 2.0 * (k6 * pow(cos(theta_t),2) + k8);
	m41 = m[3][0] = -k7 * cos(theta_t) * sin(theta_r) + 2.0 * k6 * pow(cos(theta_t),2);
	m44 = m[3][3] = 2.0 * (k6 * pow(cos(theta_t),2) + k8);

        m[1][2] = m[1][3] = m[2][1] = m[2][3] = m[3][1] = m[3][2] = 0.0;

        	/* calculating the determinant */

	D_m = -m41*m33*m22*m14 - m44*m31*m22*m13 + m44*m11*m22*m33 - m44*m12*m21*m33;

	/* Cofactors */

	M[0][0] = m22*m33*m44;
	M[0][1] = -m21*m33*m44;
	M[0][2] = -m22*m31*m44;
	M[0][3] = -m22*m33*m41;
	M[1][0] = -m44*m12*m33;
	M[1][1] = -m41*m33*m14 + m44*m11*m33 - m44*m13*m31;
	M[1][2] = m31*m12*m44;
	M[1][3] = m41*m12*m33;
	M[2][0] = -m44*m22*m13;
	M[2][1] = m13*m21*m44;
	M[2][2] = -m41*m22*m14 + m44*m11*m22 - m44*m12*m21;
	M[2][3] = m41*m22*m13;
	M[3][0] = -m14*m22*m33;
	M[3][1] = m14*m21*m33;
	M[3][2] = m14*m22*m31;
	M[3][3] = -m31*m22*m13 + m33*m11*m22 - m33*m12*m21;

	/* calculating the elements of the inertia matrix inverse */

	for (i=0; i<=3; i++)
	    for (j=0; j<=3; j++)
	         I[i][j] = M[j][i]/D_m;

        // PARAMETER
// *********
        float lambda = 0.5; 

        s[0] = 2.0 * (theta_p - theta_0[0])/dt - vel_pd - vel_hat[0] + lambda * (2.0 * theta_p - theta_pd - theta_hat[0]);
        theta_0[0] = theta_p;
        s[1] = 2.0 * (theta_t - theta_0[1])/dt - vel_td - vel_hat[1] + lambda * (2.0 * theta_t - theta_td - theta_hat[1]);
        theta_0[1] = theta_t;
        s[2] = 2.0 * (theta_l - theta_0[2])/dt - vel_vd - vel_hat[2] + lambda * (2.0 * theta_l - theta_vd - theta_hat[2]);
        theta_0[2] = theta_l;
        s[3] = 2.0 * (theta_r - theta_0[3])/dt - vel_vd - vel_hat[3] + lambda * (2.0 * theta_r - theta_vd - theta_hat[3]);
        theta_0[3] = theta_r;

        s_hat[0] =  vel_hat[0] - vel_pd  + lambda * (2.0 * theta_p - theta_pd - theta_hat[0]);
        s_hat[1] =  vel_hat[1] - vel_td  + lambda * (2.0 * theta_t - theta_td - theta_hat[1]);
        s_hat[2] =  vel_hat[2] - vel_vd  + lambda * (2.0 * theta_l - theta_vd - theta_hat[2]);
        s_hat[3] =  vel_hat[3] - vel_vd  + lambda * (2.0 * theta_r - theta_vd - theta_hat[3]);

        for (i=0; i<=3; i++)
	    for (j=0; j<=3; j++)
	         slide[i] = s_hat[j] * I[j][i];

        //printf("s[0]=%f s[1]=%f s[2]=%f s[3]=%f\n", s[0], s[1], s[2], s[3]);

                /* ************ WEIGHT UPDATE *********** */

                        double ip1[q1], ip2[q2], ip3[q3], ip4[q4];

            ip1[0] = sin(theta_t);
			ip1[1] = cos(theta_t);
			ip1[2] = sin(theta_l);
			ip1[3] = sin(theta_r);
			ip1[4] = vel_pd;
			ip1[5] = vel_td;
			ip1[6] = vel_vd;
			ip1[7] = sin(2.0*theta_t);

            ip2[0] = 9.8*sin(theta_t);
			ip2[1] = 9.8*cos(theta_t);
			ip2[2] = sin(theta_l);
			ip2[3] = sin(theta_r);
			ip2[4] = vel_pd;
			ip2[5] = vel_td;
			ip2[6] = vel_vd;

            ip3[0] = sin(theta_t);
			ip3[1] = cos(theta_t);
			ip3[2] = cos(theta_l);
            ip3[3] = vel_pd;
            ip3[4] = vel_td;
            ip3[5] = vel_vd;

            ip4[0] = sin(theta_t);
			ip4[1] = cos(theta_t);
			ip4[2] = cos(theta_r);
            ip4[3] = vel_pd;
            ip4[4] = vel_td;
            ip4[5] = vel_vd;

//fprintf(fp,"%2f %2f %2f %2f %2f %2f %2f %2f \n", t, ip2[0], ip2[1], ip2[2], ip2[3], ip2[4], ip2[5], ip2[6]);
//fprintf(fp,"%2f %2f %2f %2f %2f %2f %2f \n", t, ip3[0], ip3[1], ip3[2], ip4[0], ip4[1], ip4[2]);

        for (i=0; i<=r1-1; i++){
                f1[i] = 1.0;
                for (j=0; j<=q1-1; j++){
                        f1[i] = f1[i] * exp(-pow((ip1[j] - ps1[i][j]),2)/pow(zig1[i][j],2));
                }
                //printf("f[%d]=%f\n",i,f[i]);
        }

        for (i=0; i<=r2-1; i++){
                f2[i] = 1.0;
                for (j=0; j<=q2-1; j++){
                        f2[i] = f2[i] * exp(-pow((ip2[j] - ps2[i][j]),2)/pow(zig2[i][j],2));
                }
                //printf("f[%d]=%f\n",i,f[i]);
        }

        for (i=0; i<=r3-1; i++){
                f3[i] = 1.0;
                for (j=0; j<=q3-1; j++){
                        f3[i] = f3[i] * exp(-pow((ip3[j] - ps3[i][j]),2)/pow(zig3[i][j],2));
                }
                //printf("f[%d]=%f\n",i,f[i]);
        }

        for (i=0; i<=r4-1; i++){
                f4[i] = 1.0;
                for (j=0; j<=q4-1; j++){
                        f4[i] = f4[i] * exp(-pow((ip4[j] - ps4[i][j]),2)/pow(zig4[i][j],2));
                }
                //printf("f[%d]=%f\n",i,f[i]);
        }

                /* ************** WEIGHT UPDATE LAW ************** */

// PARAMETERS
// **********
        float Lambda[4], kapp[4];

        Lambda[0] = 0.05;       Lambda[1] = 0.02;      Lambda[2] = 0.00001;      Lambda[3] = 0.00001;
        kapp[0]   = 0.001;      kapp[1]   = 0.001;     kapp[2]   = 0.0001;       kapp[3]   = 0.0001;

                for (i=0; i<=r1-1; i++){
                        w01[i] = 0.0;
                }
                for (i=0; i<=r2-1; i++){
                        w02[i] = 0.0;
                }
                for (i=0; i<=r3-1; i++){
                        w03[i] = 0.0;
                }
                for (i=0; i<=r4-1; i++){
                        w04[i] = 0.0;
                }

        /* *** Calculate the first terms, fsI[i][j], of the RHS of weight tuning law and then update the weights *** */

        double sI[4], fsI1[r1], fsI2[r2], fsI3[r3], fsI4[r4];

        for (i=0; i<=3; i++){
                sI[i] = 0.0;
                for (j=0; j<=3; j++){
                        sI[i] = sI[i] + s[j] * I[j][i]/0.9;  //0.9 to represent uncertainty in the M matrix
                }
        }
        //printf("sI[0]=%f sI[1]=%f sI[2]=%f sI[3]=%f\n", sI[0], sI[1], sI[2], sI[3]);

        for (i=0; i<=r1-1; i++){
                        fsI1[i] = f1[i] * sI[0];
        }
        for (i=0; i<=r2-1; i++){
                        fsI2[i] = f2[i] * sI[1];
        }
        for (i=0; i<=r3-1; i++){
                        fsI3[i] = f3[i] * sI[2];
        }
        for (i=0; i<=r4-1; i++){
                        fsI4[i] = f4[i] * sI[3];
        }

//printf("%f %f %f %f %f %f %f %f\n", fsI[0][2], fsI[1][2], fsI[2][2], fsI[3][2], fsI[0][3], fsI[1][3], fsI[2][3],
//        fsI[3][3]);

        for (i=0; i<=r1-1; i++){
                w1[i] = w1[i] + dt * (-fsI1[i] + kapp[0] * (w01[i] - w1[i])) * Lambda[0];
                //printf("w[%d][2]=%f\n",i,w[i][2]);
        }

        for (i=0; i<=r2-1; i++){
                w2[i] = w2[i] + dt * (-fsI2[i] + kapp[1] * (w02[i] - w2[i])) * Lambda[1];
                //printf("w[%d][2]=%f\n",i,w[i][2]);
        }

        for (i=0; i<=r3-1; i++){
                w3[i] = w3[i] + dt * (-fsI3[i] + kapp[2] * (w03[i] - w3[i])) * Lambda[2];
                //printf("w[%d][2]=%f\n",i,w[i][2]);
        }

        for (i=0; i<=r4-1; i++){
                w4[i] = w4[i] + dt * (-fsI4[i] + kapp[3] * (w04[i] - w4[i])) * Lambda[3];
                //printf("w[%d][2]=%f\n",i,w[i][2]);
        }

  //printf("%2f %4f %4f %4f %4f\n", t, w[0][2], w[1][2], w[2][2], w[3][2]);

        /* ******* CONTROL LAW'S NEURAL ESTIMATE TERM ******* */

                v[0] = 0.0;
                for (j=0; j<=r1-1; j++){
                        v[0] = v[0] + w1[j] * f1[j];
                        //printf("v[%d]=%f\n",i,v[i]);
    		}

                v[1] = 0.0;
                for (j=0; j<=r2-1; j++){
                        v[1] = v[1] + w2[j] * f2[j];
                        //printf("v[%d]=%f\n",i,v[i]);
    		}

                v[2] = 0.0;
                for (j=0; j<=r3-1; j++){
                        v[2] = v[2] + w3[j] * f3[j];
                        //printf("v[%d]=%f\n",i,v[i]);
    		}

                v[3] = 0.0;
                for (j=0; j<=r4-1; j++){
                        v[3] = v[3] + w4[j] * f4[j];
                        //printf("v[%d]=%f\n",i,v[i]);
    		}

//fprintf(fp,"%2f %4f %4f %6f %6f \n", t, v[0], v[1], v[2]*1000, v[3]*1000);

	/* ******** CONTROL LAW'S SLIDING MODE TERM ******** */

        for (i=0; i<=3; i++){
                if ( slide[i] >= 0) {
                        sign[i] = 1.0;
                }
                        else {
                                sign[i] = -1.0;
                        }
        }

           /* ************ DYNAMIC SIMULAITON *********** */

        float h[4], F[4];

	/* centrifugal, corriolis and gravity terms */


	h[0] = k7 * cos(theta_t) * ((cos(theta_l)-cos(theta_r)) * pow(vel_t,2) + cos(theta_l) * pow(vel_l,2) -
	      cos(theta_r) * pow(vel_r,2)) + 2.0 * (k3 * sin(2.0*theta_t) + k7 * sin(theta_t) * (sin(theta_l)+
	      sin(theta_r))) * vel_p*vel_t - 2.0 * k7 * cos(theta_t) * cos(theta_l) * vel_p*vel_l -
	      2.0 * k7 * cos(theta_t) * cos(theta_r) * vel_p*vel_r - 2.0 * (k6 * sin(2.0*theta_t) +
	      k7 * sin(theta_t) * sin(theta_l)) * vel_t*vel_l - 2.0 * (k6 * sin(2.0*theta_t) -
	      k7 * sin(theta_t) * sin(theta_r)) * vel_t*vel_r;
	h[1] = -(2.0 * k3 * cos(theta_t) - 4.0 * k6 * cos(theta_t) + k7 * sin(theta_r) +
	      k7 * sin(theta_l)) * sin(theta_t) * pow(vel_p,2) + k6 * sin(2.0*theta_t) * ( 2.0 * pow(vel_l,2)
              + pow(vel_r,2) - 2.0 * vel_p * vel_l + 2.0 * vel_p * vel_r) + k9*9.8*sin(theta_t) + k10*9.8*cos(theta_t);
	h[2] = 2.0 * k6 * sin(2.0*theta_t) * (vel_p * vel_t - vel_t * vel_l) +
	      k7 * cos(theta_t) * cos(theta_l) * pow(vel_p,2);
	h[3] = -2.0 * k6 * sin(2.0*theta_t) * (vel_p * vel_t + vel_t * vel_r) +
	      k7 * cos(theta_t) * cos(theta_r) *pow(vel_p,2);


        F[0] = 0.1  * vel_p;
        F[1] = 0.1  * vel_t;
        F[2] = 0.01 * vel_l;
        F[3] = 0.01 * vel_r;

        for (i=0; i<=3; i++){
                h[i] = h[i] + F[i];
        }

        // ******* CONTROL LAW *********

        float epsilon[4];
        epsilon[0] = 0.001;      epsilon[1] = 0.00001;    epsilon[2] = epsilon[3] = 0.0;

                for (i=0; i<=3; i++){
                        T[i] = 0.0;
                        for (j=0; j<=3; j++){
                                T[i] = T[i] + 0.9*m[i][j] * nu[j];   //0.9 to represent uncertainty in the M matrix
                        }
                        T[i] = T[i] + v[i] + 0.0 * sign[i];          //epsilon = 0.0
                        //printf("T[%d]=%f\n",i,T[i]);
                }

	/* Calculating acceleration vector */

      acc_p[0] = I[0][0] * (T[0] - h[0]) + I[0][1] * (T[1] - h[1]) + I[0][2] * (T[2] - h[2]) + I[0][3] * (T[3] - h[3]);
      acc_t[0] = I[1][0] * (T[0] - h[0]) + I[1][1] * (T[1] - h[1]) + I[1][2] * (T[2] - h[2]) + I[1][3] * (T[3] - h[3]);
      acc_l[0] = I[2][0] * (T[0] - h[0]) + I[2][1] * (T[1] - h[1]) + I[2][2] * (T[2] - h[2]) + I[2][3] * (T[3] - h[3]);
      acc_r[0] = I[3][0] * (T[0] - h[0]) + I[3][1] * (T[1] - h[1]) + I[3][2] * (T[2] - h[2]) + I[3][3] * (T[3] - h[3]);

 // ***************************XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX********************************************
              
// fprintf(fp, "%4f %4f %4f %4f %4f \n",t,acc_p[0],acc_t[0],acc_l[0],acc_r[0]);
         
         /* Euler method to get angles and angular velocities */
         
         theta_p = theta_p + vel_p * dt + acc_p[0] * pow(dt,2)/2.0;
         theta_t = theta_t + vel_t * dt + acc_t[0] * pow(dt,2)/2.0;
         theta_l = theta_l + vel_l * dt + acc_l[0] * pow(dt,2)/2.0;
         theta_r = theta_r + vel_r * dt + acc_r[0] * pow(dt,2)/2.0;
         
         theta_v = (theta_l + theta_r)/2.0;
         
         vel_p = vel_p + acc_p[0] * dt;
         vel_t = vel_t + acc_t[0] * dt;
         vel_l = vel_l + acc_l[0] * dt;
         vel_r = vel_r + acc_r[0] * dt;
         
//fprintf(fp, "%4f %4f %4f %4f %4f %4f \n", t, theta_p, theta_t, theta_l, theta_r, theta_v);

//******* TARGET PROJECTIONS WHEN THE HEAD IS AT REST *******

         nocont(rhos, phis, gammas, dnc, xnc, ync, x_lnc, y_lnc, x_rnc, y_rnc);

if (jj % 10 == 0){
fprintf(fp, "%4f %4f %4f %4f %4f \n", t, x_lnc[0], y_lnc[0], x_rnc[0], y_rnc[0]);
}

//*******************************************************

}
       fclose(fp);
       return 0;
}
